------------------------------------------------------------------------------------------------
---------------------------------- DON'T EDIT THESE LINES --------------------------------------
------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------
---------------------------------- DON'T EDIT THESE LINES --------------------------------------
------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------
---------------------------------- DON'T EDIT THESE LINES --------------------------------------
------------------------------------------------------------------------------------------------

--**TODO: MISSION PICKUPS, NEW PLAYER CHECKS (MAYBE). 
--**spacetime on server


local MissionName = "N/A"
local Active      = 0
local PedsSpawned = 0
local securing    = false
local playerSecured = false
local playerMissionMoney = 0
local showNativeMoneyGUI = false 
local _,currentplayerNmoney = StatGetInt('MP0_WALLET_BALANCE', -1)
local blKeepPropsOnGround = false --**turn to false if you are experiencing desync**

--NOT NEEDED ANYMORE:
local checkspawns = false --used to make sure ped/veh spawns OK in IsRandom missions

--experimental, used to make sure that NPC blips show up for players,
--when the connect and starting new missions:
local blForceCheckForBlips = true
local blForceCheckForBlipsTimeout = 30000 --30 seconds default


--for GTAO sounds
SetAudioFlag("LoadMPData", true)

Blips = {}

DecorRegister("mrppedid",1)
DecorRegister("mrpvpedid",1)
DecorRegister("mrpvehdid",1)
DecorRegister("mrppickupid",1)
DecorRegister("mrpmpickupid",1)
DecorRegister("mrppropid",1)
DecorRegister("mrppedtarget",1)
DecorRegister("mrppedfriend",1)
DecorRegister("mrpcheckspawn",1) --used to make sure ped/veh spawns OK in IsRandom missions
DecorRegister("mrppedconqueror",1) --used for .conqueror and .attacker npcs
DecorRegister("mrprescuecount",1) --used on player for hostage rescue count



local spawnablePickups =
{
	"PICKUP_WEAPON_PISTOL",
	"PICKUP_WEAPON_SMG",
	"PICKUP_WEAPON_ASSAULTRIFLE",
}

----------------------------
--------- Kit de Soin ---------
----------------------------

local defibItemName = 'defib'

-- Function to use defibrillator
local function useDefib()
	local closestPlayer, closestDistance = ESX.Game.GetClosestPlayer()
							
	if closestPlayer == -1 or closestDistance > 3.0 then
		ESX.ShowNotification("aucun joueur a proximité")
	else
		ESX.TriggerServerCallback('esx_ambulancejob:getItemAmount', function(qtty)
			if qtty > 0 then
				local closestPlayerPed = GetPlayerPed(closestPlayer)
				local health = GetEntityHealth(closestPlayerPed)
				
				if health == 0 then
					local playerPed = GetPlayerPed(-1)
					
					ESX.ShowNotification("Vous procurez les premiers soin")
					TaskStartScenarioInPlace(playerPed, 'CODE_HUMAN_MEDIC_TEND_TO_DEAD', 0, true)
					Citizen.Wait(10000)
					ClearPedTasks(playerPed)
					
					TriggerServerEvent('esx_ambulancejob:removeItem',defibItemName)
					TriggerServerEvent('esx_ambulancejob:revive', GetPlayerServerId(closestPlayer))
				else
					ESX.ShowNotification("Pas Mort ou est au ciel!")
				end
			else
				ESX.ShowNotification("Vous ne pouvez pas aidez!")
			end
		end, defibItemName)
	end
end

-- Simple loop to call the defibrillator function if "N9" is pressed
Citizen.CreateThread(function()
	while true do
		Citizen.Wait(5)
		if(IsControlJustReleased(1, 118))then
			useDefib()
		end
	end
end)


---enumerate functions

--[[Usage:
for ped in EnumeratePeds() do
  <do something with 'ped'>
end
]]

local entityEnumerator = {
  __gc = function(enum)
    if enum.destructor and enum.handle then
      enum.destructor(enum.handle)
    end
    enum.destructor = nil
    enum.handle = nil
  end
}

local function EnumerateEntities(initFunc, moveFunc, disposeFunc)
  return coroutine.wrap(function()
    local iter, id = initFunc()
    if not id or id == 0 then
      disposeFunc(iter)
      return
    end
    
    local enum = {handle = iter, destructor = disposeFunc}
    setmetatable(enum, entityEnumerator)
    
    local next = true
    repeat
      coroutine.yield(id)
      next, id = moveFunc(iter)
    until not next
    
    enum.destructor, enum.handle = nil, nil
    disposeFunc(iter)
  end)
end

function EnumerateObjects()
  return EnumerateEntities(FindFirstObject, FindNextObject, EndFindObject)
end

function EnumeratePeds()
  return EnumerateEntities(FindFirstPed, FindNextPed, EndFindPed)
end

function EnumerateVehicles()
  return EnumerateEntities(FindFirstVehicle, FindNextVehicle, EndFindVehicle)
end

function EnumeratePickups()
  return EnumerateEntities(FindFirstPickup, FindNextPickup, EndFindPickup)
end


---
---ESX SUPPORT
---
local UseESX=true
if UseESX then
	ESX = nil
	Citizen.CreateThread(function()
		while ESX == nil do
		TriggerEvent("esx:getSharedObject", function(obj) ESX = obj end)
		Citizen.Wait(1)
		end
	end)
		RegisterNetEvent("esx:playerLoaded")
		AddEventHandler("esx:playerLoaded", function(xPlayer)
		PlayerData = xPlayer
	end)

end




---
---
---

----------------------------
--------- Commands ---------
----------------------------

--looks for setting within a mission, else looks at global setting
function getMissionConfigProperty(MissionName, PropName) 
	--print('MissionName'..MissionName)
	--print('PropName'..PropName)
	for i, v in pairs(Config.Missions[MissionName]) do
        if PropName == i then
			return v
			
        end
    end

	for i, v in pairs(Config) do
		if PropName == i then
			if(PropName == "RandomMissionMaxPedSpawns") then 
			end 
			return v
			
        end
    end
	
			
end



RegisterCommand("mission", function(source, args, rawCommand)
    input = args[1]

	
        for i, v in pairs(Config.Missions) do
            if input == i then
				local rMissionLocationIndex = 0
				local rMissionType = getMissionConfigProperty(input, "RandomMissionTypes")[math.random(1, #getMissionConfigProperty(input, "RandomMissionTypes"))]			
			
                if Active == 1 then
                    TriggerEvent('chatMessage', "^1[MISSIONS]: ^2There is a mission already in progress.")
                else
					Active = 1
					MissionName = input
					time = 10000
					if(Config.Missions[MissionName].IsRandom) then 
						rMissionLocationIndex = math.random(1, #getMissionConfigProperty(MissionName, "RandomMissionPositions"))
						
						--[[
						if(getMissionConfigProperty(input, "RandomLocation")) then
							--find if in water
							local x = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].x
							local y = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].y
							local z = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].z
							
							--local zGround = checkAndGetGroundZ(500.0,4200.0,z,true)
							
							--print("RandomLocation:zGround"..tostring(zGround))
							--local isWater = Citizen.InvokeNative( 0x8974647ED222EA5F,4200.0, 500.0, 1000.0,4200.0, 500.0,-500.0,Citizen.ReturnResultAnyway())
							
							--print(isWater.z)
							
							--if TestVerticalProbeAgainstAllWater(-1200.0,2700.0,500.0,0) then --TestVerticalProbeAgainstAllWater(500.0,4200.0,0.0,1,500)
								--print("RandomLocation:FOUND WATER")
							--end
							
						
						end 
						]]--
						
						
						if(getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].force) then
							
							rMissionType = "Objective" --NPCs have a chance of spawning hidden in buildings with forced = true, so Assassinate may hang
						end
						
						SetRandomMissionAttributes(MissionName,rMissionType,getMissionConfigProperty(MissionName, "RandomMissionPositions")[rMissionLocationIndex]) 
					else 
						
						rMissionType = Config.Missions[MissionName].Type
					
					end
					
					TriggerServerEvent("sv:one",input, Config.Missions[MissionName].MissionTitle, time,rMissionLocationIndex,rMissionType)
					
					if(Config.Missions[MissionName].IsRandom) then 
						--MissionName,MissionType,NumPeds,NumVehicles,locationIndex
						
						--print("DONE:"..math.random(getMissionConfigProperty(MissionName "RandomMissionMinVehicleSpawns"),getMissionConfigProperty(MissionName, "RandomMissionMaxVehicleSpawns"))
						
						TriggerEvent("SpawnRandomPed", input,rMissionType, math.random(getMissionConfigProperty(MissionName, "RandomMissionMinPedSpawns"), getMissionConfigProperty(MissionName, "RandomMissionMaxPedSpawns")), math.random(getMissionConfigProperty(MissionName, "RandomMissionMinVehicleSpawns"),getMissionConfigProperty(MissionName, "RandomMissionMaxVehicleSpawns")),rMissionLocationIndex)
					else
						
						TriggerEvent("SpawnPed", input)
					end
					
					
					--Wait 5 seconds for peds to spawn on client/host and migrate to other clients.
					--before spawning NPC blips etc..
					--Wait(5000)					
					
					--TriggerServerEvent("sv:one",input, Config.Missions[MissionName].MissionTitle, time,rMissionLocationIndex,rMissionType)
				
				end
            end
        end
    
end, false)

RegisterCommand("stop", function(source, args, rawCommand)
    if Active == 0 then
        TriggerEvent('chatMessage', "^1[MISSIONS]: ^2There is not a Mission in Progress.")
    else
        Active = 0
		message2 = "^1[MISSIONS]: ^2'".. Config.Missions[MissionName].MissionTitle .."'^0 has been completed!"
        TriggerServerEvent("sv:two", message2)
		TriggerServerEvent("sv:done", MissionName,true,false,"")
        --TriggerEvent("DONE", MissionName) --ghk needed?
        aliveCheck()
        MissionName = "N/A"
    end
end, false)

RegisterCommand("list", function(source, rawCommand)
    for i, v in pairs(Config.Missions) do
        TriggerEvent('chatMessage', "^1[MISSION LIST]: ^2".. i .."")
    end 
end, false)

--------------------------
--------- Events ---------
--------------------------

--tells client to check for suspicious spawns looking for the mrpcheckspawn decor value > 0
RegisterNetEvent("mt:checkspawns")
AddEventHandler("mt:checkspawns", function(docheckspawns)

	checkspawns = docheckspawns
		
end)


--called from server when player first logs in
RegisterNetEvent("mt:setactive")
AddEventHandler("mt:setactive", function(activeflag,input,onlineplayers,docheckspawns)
    local currentplayercount = onlineplayers
	local rMissionLocationIndex = 0
	local rMissionType = getMissionConfigProperty(input, "RandomMissionTypes")[math.random(1, #getMissionConfigProperty(input, "RandomMissionTypes"))]
	
	if activeflag == 1 then
	
		Active = activeflag
		MissionName = input
		
		
		
		--MissionNumber = tonumber(string.sub(MissionName, -1))
		TriggerEvent('chatMessage',"^1[MISSIONS]: ^2'".. Config.Missions[MissionName].MissionTitle.."'^0 has been launched.")
		
		TriggerEvent("mt:missiontext", MissionName, 10000)
		
		if(Config.Missions[MissionName].IsRandom) then 
			rMissionLocationIndex = math.random(1, #getMissionConfigProperty(input, "RandomMissionPositions"))
			
				if(getMissionConfigProperty(MissionName, "RandomMissionPositions")[rMissionLocationIndex].force) then
					
					rMissionType = "Objective" --NPCs have a chance of spawning in buildings with forced = true, so Assassinate may hang
				end	
						
		end 		
		TriggerEvent('missionBlips',  MissionName,rMissionLocationIndex,rMissionType)				
		if(currentplayercount == 1) then 
			--mission is currently running on server (ActiveMission=true), and they are only player
			--start mission for them and spawn peds, set mission blip, and NPC blips
			
			if(Config.Missions[MissionName].IsRandom) then 
				TriggerEvent("SpawnRandomPed", input,rMissionType, math.random(getMissionConfigProperty(MissionName, "RandomMissionMinPedSpawns"), getMissionConfigProperty(MissionName, "RandomMissionMaxPedSpawns")), math.random(getMissionConfigProperty(MissionName, "RandomMissionMinVehicleSpawns"),getMissionConfigProperty(MissionName, "RandomMissionMaxVehicleSpawns")),rMissionLocationIndex)
			else
				TriggerEvent("SpawnPed", input)		
			end	
			--wait 5 seconds for the peds to spawn
			--Wait(5000)
			--print('SETACTIVE')
			--TriggerEvent('missionBlips',  MissionName,rMissionLocationIndex,rMissionType)		
			TriggerEvent("SpawnPedBlips", input)
			
		elseif(currentplayercount > 0) then 
		
			--mission is running on server (ActiveMission=true) and there are other players
			--enable mission for them, dont spawn peds, but set mission blip and NPC blips
			--also set whether suspicious spawns need to be checked
			checkspawns = docheckspawns
			--make joining players wait 5seconds too
			--Wait(5000)
			--TriggerEvent('missionBlips',  MissionName,rMissionLocationIndex,rMissionType)		
			TriggerEvent("SpawnPedBlips", input)
		
		else 
			--SHOULD NEVER HAPPEN
			print('FOUND 0 PLAYERS: NO MISSIONS')
			Active = 0
			MissionName = "N/A"
		
		end
		
		
		
		--Citizen.Wait(500)
		--TriggerEvent('chatMessage', "^1[MISSIONS]: ^2Mission already in progress. Wait till it is completed or use '/stop' command")
		--Citizen.Wait(500)
		--TriggerEvent('chatMessage', "^1[MISSIONS]: ^2 Use '/list' to find missions. To start a mission use '/mission Mission1' (etc..)")				
		
	else 
		
		TriggerEvent('chatMessage', "^1[MISSIONS]: ^2 Use '/list' to find missions. To start a mission use '/mission Mission1' (etc..)")
		TriggerEvent('chatMessage', "^1[MISSIONS]: ^2 Use '/stop' command to stop a mission ")	
	end
	   
end)

RegisterNetEvent("mt:missiongeneraltext")
AddEventHandler("mt:missiongeneraltext", function(input,message, time)
	--Active = 1 --GHK Make sure this is set for all clients for mission start
		MissionName = input  --GHK Make sure this is set for all clients for mission start
        text = message
        ClearPrints()
        SetTextEntry_2("STRING")
        AddTextComponentString(text)
        DrawSubtitleTimed(time, 1)
		
end)

RegisterNetEvent("mt:missiontext")
AddEventHandler("mt:missiontext", function(input, time)
	Active = 1 --GHK Make sure this is set for all clients for mission start
	MissionName = input  --GHK Make sure this is set for all clients for mission start
    for i=1, #Config.Missions[input].StartMessage do
        text = Config.Missions[input].StartMessage
        ClearPrints()
        SetTextEntry_2("STRING")
        AddTextComponentString(text)
        DrawSubtitleTimed(time, 1)
		
    end
end)

RegisterNetEvent("mt:removepickups")
AddEventHandler("mt:removepickups", function(oldmission)
	if(Config.CleanupPickups) then	
		CleanupPickups(oldmission,true)
	end
end)

RegisterNetEvent("mt:missiontext2")
AddEventHandler("mt:missiontext2", function(input, time)
    text = input
    ClearPrints()
    SetTextEntry_2("STRING")
    AddTextComponentString(text)
    DrawSubtitleTimed(time, 1)
end)

RegisterNetEvent('missionBlips') --**added SpawnMissionPickups to this for clients**
AddEventHandler('missionBlips', function(input,rMissionLocationIndex,rMissionType)
	 local blip
	
	
	if Config.Missions[input].IsRandom then
		Config.Missions[input].Type = rMissionType

		
		--allow custom blips each random location
		if getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Blip then
			Config.Missions[input].Blip.Position.x = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Blip.Position.x
			Config.Missions[input].Blip.Position.y = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Blip.Position.y
			Config.Missions[input].Blip.Position.z = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Blip.Position.z
			Config.Missions[input].Blip.Icon = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Blip.Icon
			Config.Missions[input].Blip.Display = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Blip.Display
			Config.Missions[input].Blip.Size = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Blip.Size
			Config.Missions[input].Blip.Color = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Blip.Color	
			Config.Missions[input].Blip.Title = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Blip.Title
			Config.Missions[input].Blip.Alpha = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Blip.Alpha	
		else
			--this is a random mission so set blip and marker values per random mission called
			Config.Missions[input].Blip.Position.x = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].x
			Config.Missions[input].Blip.Position.y = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].y
			Config.Missions[input].Blip.Position.z = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].z
		
		end
		--allow custom markers each random location
		if getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Marker then
		--print('FOUND RMISSION MARKER')
			Config.Missions[input].Marker.Position.x = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Marker.Position.x
			Config.Missions[input].Marker.Position.y = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Marker.Position.y
			Config.Missions[input].Marker.Position.z = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Marker.Position.z - 1 --Markers seem to need to come down by 1 unit from the z coordinate to be on the ground, same with props			
			Config.Missions[input].Marker.Type = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Marker.Type
			Config.Missions[input].Marker.DrawDistance = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Marker.DrawDistance 
			
			Config.Missions[input].Marker.Size.x = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Marker.Size.x
			Config.Missions[input].Marker.Size.y = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Marker.Size.y
			Config.Missions[input].Marker.Size.z = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Marker.Size.z 

			Config.Missions[input].Marker.Color.r = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Marker.Color.r
			Config.Missions[input].Marker.Color.g = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Marker.Color.g
			Config.Missions[input].Marker.Color.b = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].Marker.Color.b 
		else
				--this is a random mission so set blip and marker values per random mission called
			Config.Missions[input].Marker.Position.x = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].x
			Config.Missions[input].Marker.Position.y = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].y
			Config.Missions[input].Marker.Position.z = getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex].z - 1 --Markers seem to need to come down by 1 unit from the z coordinate to be on the ground, same with props
		
			
		end

		SetRandomMissionAttributes(input,rMissionType, getMissionConfigProperty(input, "RandomMissionPositions")[rMissionLocationIndex]) 		

		
	end 
	
	local blip
	local btitle = Config.Missions[input].Blip.Title
	if Config.Missions[input].IsDefend then --and Config.Missions[input].Type == "Assassinate" then

		blip = AddBlipForRadius(Config.Missions[input].Marker.Position.x, Config.Missions[input].Marker.Position.y, Config.Missions[input].Marker.Position.z,Config.Missions[MissionName].Marker.Size.x / 2)
		
		SetBlipColour (blip, Config.Missions[input].Blip.Color)
		SetBlipAlpha(blip,80)
		local btitle = Config.Missions[input].Blip.Title
		BeginTextCommandSetBlipName("STRING")
		
		if tostring(getObjectiveReward(input)) ~= "N/A" then 
			AddTextComponentString(btitle.." ($"..getObjectiveReward(input)..")")
		else 
			AddTextComponentString(btitle)
		end
		EndTextCommandSetBlipName(blip)		
		--print("WHOLE CIRCLE BLIP")
	else 
		blip = AddBlipForCoord(Config.Missions[input].Blip.Position.x, Config.Missions[input].Blip.Position.y, Config.Missions[input].Blip.Position.z)
		SetBlipSprite (blip, Config.Missions[input].Blip.Icon)
		SetBlipDisplay(blip, Config.Missions[input].Blip.Display)
		SetBlipScale  (blip, Config.Missions[input].Blip.Size)
		SetBlipColour (blip, Config.Missions[input].Blip.Color)
		SetBlipAsShortRange(blip, false)
		local btitle = Config.Missions[input].Blip.Title
		BeginTextCommandSetBlipName("STRING")
		
		if tostring(getObjectiveReward(input)) ~= "N/A" then 
			AddTextComponentString(btitle.." ($"..getObjectiveReward(input)..")")
		else 
			AddTextComponentString(btitle)
		end
		EndTextCommandSetBlipName(blip)	
	
	
	end
	
    table.insert(Blips, blip)
	--***********
	SpawnMissionPickups(input) 
	
end)

RegisterNetEvent('DONE')
AddEventHandler('DONE', function(input,isstop,isfail,reasontext)
		local targetPedsKilledByPlayer = 0
		local nontargetPedsKilledByPlayer = 0
		local hostagePedsKilledByPlayer = 0
		local totalDeadHostages = 0
		local results
	if(not isstop and not isfail) then

		results = calcMissionStats()
		nontargetPedsKilledByPlayer = results[1]
		targetPedsKilledByPlayer = results[2]
		hostagePedsKilledByPlayer = results[3]
		totalDeadHostages = results[6]
		calcCompletionRewards(nontargetPedsKilledByPlayer,targetPedsKilledByPlayer,hostagePedsKilledByPlayer,totalDeadHostages)
	end
	
	if (isfail) then 
		results = calcMissionStats()
		hostagePedsKilledByPlayer = results[3]
		totalDeadHostages = results[6]
		calcHostageKillPenalty(hostagePedsKilledByPlayer,totalDeadHostages)
	end
	
	if(Config.Missions[input].IsRandom) then 
		--'remove' the old up the old Marker before new mission
		--workaround for now for with the old marker blinking in
		--between random missions
		Config.Missions[input].Marker.Position.x = -10000.0
		Config.Missions[input].Marker.Position.y = -10000.0
		Config.Missions[input].Marker.Position.z = 0.0
	
	end
	
	
	local rewardPlayer=false
	if(Config.Missions[input].Type == "Assassinate" and targetPedsKilledByPlayer > 0)  or (Config.Missions[input].Type == "Objective" and playerSecured) then
		rewardPlayer=true
	end 
	
	if(not isstop and not isfail) then
		SpawnPickups(input,rewardPlayer) 
		PlaySoundFrontend(-1, "MEDAL_UP", "HUD_MINI_GAME_SOUNDSET", 1)
	else 
		CleanupPickups(input,true) --cleanup mission pickups
	end	
	
	if (not isstop and isfail) then 
		--PlaySoundFrontend(-1, "LOOSE_MATCH", "HUD_MINI_GAME_SOUNDSET", 1)
		PlaySoundFrontend(-1, "Crash", "DLC_HEIST_HACKING_SNAKE_SOUNDS", 1) 
	end
	
	
	
	for ped in EnumeratePeds() do
	
		if DecorGetInt(ped, "mrppedid") > 0   then
			local blip = GetBlipFromEntity(ped)
			RemoveBlip(blip)
			DeleteEntity(ped)
			
			
		end

		if  DecorGetInt(ped, "mrpvpedid") > 0 then
			local blip = GetBlipFromEntity(ped)
			RemoveBlip(blip)
			DeleteEntity(ped)
			
		end

	end		
	
	for veh in EnumerateVehicles() do

		if DecorGetInt(veh, "mrpvehdid") > 0 then
			local blip = GetBlipFromEntity(veh)
			RemoveBlip(blip)
			DeleteEntity(veh)
		end

	end	
	
	for obj in EnumerateObjects() do

		if DecorGetInt(obj, "mrppropid") > 0 then
			DeleteObject(obj)	
		end
	end		
	
	--[[
    for i=1, #Config.Missions[input].Peds do
        local ped  = Config.Missions[input].Peds[i].id
        local blip = GetBlipFromEntity(ped)
        RemoveBlip(blip)
        DeleteEntity(Config.Missions[input].Peds[i].id)
    end
    for i=1, #Config.Missions[input].Vehicles do
        local veh  = Config.Missions[input].Vehicles[i].id
        local ped  = Config.Missions[input].Vehicles[i].id2
        --local blip = GetBlipFromEntity(veh)
		local blip = GetBlipFromEntity(ped)
        RemoveBlip(blip)
        DeleteEntity(ped)
        DeleteEntity(veh)
    end
	
	]]--
		
	--print('DONE CALLED playerMissionMoney is:'..playerMissionMoney)
    for i, blip in pairs(Blips) do
		RemoveBlip(blip)
    end
	
	if(not isstop) then 
		local reasonmessage = ""
		if string.len(reasontext) > 0 then 
			
			reasonmessage = "~n~"..reasontext
		end
	
	
		ClearPrints()
		SetTextColour(99, 209, 62, 255)
		SetTextEntry_2("STRING")
		if (not isfail) then 
			AddTextComponentString(getMissionConfigProperty(input, "FinishMessage")..reasonmessage.."~n~You Earned $"..playerMissionMoney)
		else 
			AddTextComponentString(getMissionConfigProperty(input, "FailedMessage")..reasonmessage.."~n~You Earned $"..playerMissionMoney)
		end
		DrawSubtitleTimed(10000, 1)	--time = 10000
	end 
	playerMissionMoney = 0
	--print('playerMissionMoney is:'..playerMissionMoney)
	CleanupProps(input) 
	    --aliveCheck()
	checkspawns = false
	PedsSpawned = 0
	playerSecured = false
    securing    = false
	Active = 0 --GHK Make sure this is set for all clients for mission end
	MissionName = "N/A"  --GHK Make sure this is set for all clients for mission end
	
end)


RegisterNetEvent('SpawnPedBlips')
AddEventHandler('SpawnPedBlips', function(input)
	--SpawnProps(input)
	--SpawnMissionPickups(input) 
	print('spawnpedblips called')
	
	if(blForceCheckForBlips) then 
	
		local i = 0
		local lastfound = GetGameTimer() 
		repeat 
			
			for ped in EnumeratePeds() do
			
				if DecorGetInt(ped, "mrppedid") > 0  or DecorGetInt(ped, "mrpvpedid") > 0 and not IsEntityDead(ped) then
			
					--for client that called SpawnPeds, blips already added
					local oldblip = GetBlipFromEntity(ped)
					--RemoveBlip(oldblip)
					if not DoesBlipExist(oldblip) then                     -- if oldblip == 0 then 
						local Size     = 0.9
						local pedblip = AddBlipForEntity(ped)
						SetBlipScale  (pedblip, Size)
						SetBlipAsShortRange(pedblip, false)
						
						
						if DecorGetInt(ped, "mrppedtarget") > 0 then
							--print('ENEMY PEDT')
							--SetBlipSprite(pedblip, 433)
							SetBlipColour(pedblip, 27)
							BeginTextCommandSetBlipName("STRING")
							AddTextComponentString("Target ($"..getTargetKillReward(input)..")")
							EndTextCommandSetBlipName(pedblip)	
								
						elseif DecorGetInt(ped, "mrppedfriend") > 0 then
							--SetBlipSprite(pedblip, 280)
							--print('ENEMY PEDF')
							SetBlipColour(pedblip, 2)	
							BeginTextCommandSetBlipName("STRING")
							AddTextComponentString("Friend ($-"..getHostageKillPenalty(input)..")")
							EndTextCommandSetBlipName(pedblip)						
							
						else
							--print('ENEMY PED')
							BeginTextCommandSetBlipName("STRING")
							AddTextComponentString("Enemy ($"..getKillReward(input)..")")
							EndTextCommandSetBlipName(pedblip)						
						
						end			
						--lastfound = GetGameTimer()
						i = i + 1
					end 
				end

			end	
			print('looking for enemy peds...'..i)
			Wait(1000)
		until (GetGameTimer() - lastfound > blForceCheckForBlipsTimeout) --defauly wait 30 seconds to stop looking 
		
		print('found enemy peds..'..i)
	else 
			for ped in EnumeratePeds() do
			
				if DecorGetInt(ped, "mrppedid") > 0  or DecorGetInt(ped, "mrpvpedid") > 0 and not IsEntityDead(ped) then
			
					--for client that called SpawnPeds, blips already added
					local oldblip = GetBlipFromEntity(ped)
					--RemoveBlip(oldblip)
					if oldblip == 0 then 
						local Size     = 0.9
						local pedblip = AddBlipForEntity(ped)
						SetBlipScale  (pedblip, Size)
						SetBlipAsShortRange(pedblip, false)
						
						
						if DecorGetInt(ped, "mrppedtarget") > 0 then
							--print('ENEMY PEDT')
							--SetBlipSprite(pedblip, 433)
							SetBlipColour(pedblip, 27)
							BeginTextCommandSetBlipName("STRING")
							AddTextComponentString("Target ($"..getTargetKillReward(input)..")")
							EndTextCommandSetBlipName(pedblip)	
								
						elseif DecorGetInt(ped, "mrppedfriend") > 0 then
							--SetBlipSprite(pedblip, 280)
							--print('ENEMY PEDF')
							SetBlipColour(pedblip, 2)	
							BeginTextCommandSetBlipName("STRING")
							AddTextComponentString("Friend ($-"..getHostageKillPenalty(input)..")")
							EndTextCommandSetBlipName(pedblip)						
							
						else
							--print('ENEMY PED')
							BeginTextCommandSetBlipName("STRING")
							AddTextComponentString("Enemy ($"..getKillReward(input)..")")
							EndTextCommandSetBlipName(pedblip)						
						
						end			
						--lastfound = GetGameTimer()
						i = i + 1
					end 
				end

			end		
	
	
	end
	
	PedsSpawned = 1 --needed for other clients
    aliveCheck()
end)


AddRelationshipGroup('HOSTAGES') 
AddRelationshipGroup('TRUENEUTRAL')

local function roundToNthDecimal(num, n)
  local mult = 10^(n or 0)
  return math.floor(num * mult + 0.5) / mult
end


function checkAndGetGroundZ(x, y, z,blFindGroundZ)
local groundFound = false
local groundCheckHeights = {0.0, 50.0, 100.0, 150.0, 200.0, 250.0, 300.0, 350.0, 400.0,450.0, 500.0, 550.0, 600.0, 650.0, 700.0, 750.0, 800.0}
local ground
			

	local unused,zGround = GetGroundZFor_3dCoord(x, y, z)
	--print("checkAndGetGroundZ: Groundz:"..zGround)
	--print("checkAndGetGroundZ:blFindGroundZ:"..tostring(blFindGroundZ)) 
	if zGround == 0.0 then 
		if blFindGroundZ then 
			
			for i,height in ipairs(groundCheckHeights) do
				RequestCollisionAtCoord(x, y, height)
				Wait(0) --< NEEDED?
				--SetEntityCoordsNoOffset(Ped, rXoffset,rYoffset,height, 0, 0, 1)
				ground,zGround = GetGroundZFor_3dCoord(x,y,height)
				if(ground) then
					zGround = zGround + 3
					groundFound = true
					break;
				end
			end
			if(not groundFound) or zGround < 0.0 then --zGround < 0.0 is water. turn off for boat missions
				--print("checkAndGetGroundZ: findZoffset:"..zGround) 
				--print("checkAndGetGroundZ: groundFound:"..tostring(groundFound)) 
				zGround = 0.0 
			else 
				--print("checkAndGetGroundZ: findZoffset:"..zGround) 
				--print("checkAndGetGroundZ: groundFound:"..tostring(groundFound)) 
				
			end
		end
	end
	--print("checkAndGetGroundZ: FinalGroundz:"..zGround) 
	return zGround

end


RegisterNetEvent('SpawnRandomPed')
AddEventHandler('SpawnRandomPed', function(input,MissionType, NumPeds,NumVehicles,rIndex)
	--if MissionType == "Objective" and not getMissionConfigProperty(input, "HostageRescue") then 
		--doing check inside the function now
		SpawnRandomProp(input,rIndex)
		
	--end 
	local randomLocation = getMissionConfigProperty(input, "RandomMissionPositions")[rIndex]
	
	local rXoffset, rYoffset,rZoffset, rHeading, _ --spawn within 40 metres of the randomlocation
	
    for i=1, NumPeds do
		
		local randomPedModelHash = getMissionConfigProperty(input, "RandomMissionPeds")[math.random(1, #getMissionConfigProperty(input, "RandomMissionPeds"))]
		local randomPedWeapon = getMissionConfigProperty(input, "RandomMissionWeapons")[math.random(1, #getMissionConfigProperty(input, "RandomMissionWeapons"))]
		local Ped
		local spawnFriendly = false
		
		
		if math.random(5) > 4 then 
			spawnFriendly = true
			randomPedModelHash = getMissionConfigProperty(input, "RandomMissionFriendlies")[math.random(1, #getMissionConfigProperty(input, "RandomMissionFriendlies"))]
		end 
		
		
        RequestModel(GetHashKey(randomPedModelHash))
        while not HasModelLoaded(GetHashKey(randomPedModelHash)) do
          Wait(1)
        end
		local raytestsuccess = true
		local spawnRadius = getMissionConfigProperty(input, "RandomMissionSpawnRadius")
		--local _unused
		local checkthisspawn = false
		rXoffset = randomLocation.x + roundToNthDecimal(math.random() + math.random(-1*spawnRadius,spawnRadius - 1),4)
		
		rYoffset = randomLocation.y + roundToNthDecimal(math.random() + math.random(-1*spawnRadius,spawnRadius - 1),4)
		
		--_unused, rZoffset = GetGroundZFor_3dCoord(rXoffset, rYoffset, randomLocation.z)
		
		--print("SPAWNPEDRANDOM")
		
		
		if not randomLocation.force then --force is on, means we are OK to not check. 
			--print("FORCE OFF")
			rZoffset = checkAndGetGroundZ(rXoffset, rYoffset,randomLocation.z,true) --LAST ARG: blFindGroundZ 
			if rZoffset == 0.0 then --flag for checkspawn
				checkspawns = true --global for all clients and mission
				checkthisspawn=true
				rZoffset = randomLocation.z   --***SPAWN AT THE DEFAULT Z POSITION? YES It will be corrected later
				
			end
		else 
			--print("FORCE ON")
			rZoffset = randomLocation.z
		end 
		
		--print("rZoffset:"..rZoffset)
		--print("checkthisspawn:"..tostring(checkthisspawn))
		--print("checkspawns:"..tostring(checkspawns))
		
		

		rHeading = roundToNthDecimal(math.random() + math.random(0,359),2)
		
		if not randomLocation.force then 
			local ray = Citizen.InvokeNative( 0x377906D8A31E5586, vector3(rXoffset, rYoffset, rZoffset) + vector3(0.0, 0.0, 1000.0), vector3(rXoffset, rYoffset, rZoffset), -1, -1, 0)
			 --local ray = StartShapeTestRay(vector3(rXoffset, rYoffset, rZoffset) + vector3(0.0, 0.0, 500.0), vector3(rXoffset, rYoffset, rZoffset), -1, -1, 0)
		   -- local _, hit, impactCoords  = Citizen.InvokeNative( 0x3D87450E15D98694, ray,hit)
			local _, hit, impactCoords = GetRaycastResult(ray) --GetShapeTesResult(ray)
			
				-- print("HIT: " .. hit)
				-- print(("IMPACT COORDS: X = %.4f; Y = %.4f; Z = %.4f"):format(impactCoords.x, impactCoords.y, impactCoords.z))
				-- print("DISTANCE BETWEEN DROP AND IMPACT COORDS: " ..  #(vector3(dropCoords.x, dropCoords.y, dropCoords.z) - vector3(impactCoords)))
			if hit == 0 or (hit == 1 and #(vector3(rXoffset, rYoffset, rZoffset) - vector3(impactCoords)) < 0.5) then -- ± 0.5 units
					--print("ROOFCHECK: success")
					raytestsuccess = true
			else
					--print("ROOFCHECK: fail")
					raytestsuccess = false
			   
			end
		end

		if  raytestsuccess then 
		
			Ped = CreatePed(2, randomPedModelHash, rXoffset, rYoffset, rZoffset, rHeading, true, true)
			
			--Add DoesEntityExist check here? 
			
			if checkthisspawn then 
				DecorSetInt(Ped,"mrpcheckspawn",1) --flag Ped to be checked to readjust if necessary later 
			else 
				DecorSetInt(Ped,"mrpcheckspawn",0)
			end
			
			if(randomPedModelHash == "S_M_M_MovAlien_01") then
				SetPedDefaultComponentVariation(Ped) --GHK for s_m_m_movalien_01
			end
			
			SetEntityAsMissionEntity(Ped,true,true)
			
			--Create 'conqueror' type NPCs 25% of the time if IsDefend mission
			if not getMissionConfigProperty(input, "IsDefend") or (getMissionConfigProperty(input, "IsDefend") and math.random(1,4) > 3) then 
			
				if (randomPedModelHash == "U_M_Y_Zombie_01" or randomPedModelHash == "s_m_m_movalien_01") then  --or randomPedModelHash ==  "IG_Orleans") then --movie zed
						SetPedFleeAttributes(Ped, 0, 0)
						SetPedCombatAttributes(Ped, 16, true)
						SetPedCombatAttributes(Ped, 46, true)
						SetPedCombatAttributes(Ped, 26, true)
						SetAmbientVoiceName(Ped, "ALIENS")
						SetPedEnableWeaponBlocking(Ped, true)			
						DisablePedPainAudio(Ped,true)
						
					--if not Config.Missions[input].Peds[i].modelHash == "IG_Orleans" then
						ApplyPedBlood(Ped, 3, math.random(0, 4) + 0.0, math.random(-0, 4) + 0.0, math.random(-0, 4) + 0.0, "wound_sheet")
						SetPedIsDrunk(Ped, true)
						RequestAnimSet("move_m@drunk@verydrunk")
						while not HasAnimSetLoaded("move_m@drunk@verydrunk") do
							Wait(1)
						end
						SetPedMovementClipset(Ped, "move_m@drunk@verydrunk", 1.0)						
					--end		
						
					--SetPedCombatRange(Ped, 2)
				  --	SetPedSeeingRange(Ped, 100000000.0)
					--SetPedHearingRange(Ped, 100000000.0)
				  --SetPedCombatAttributes(Ped, 46, true);
				 -- SetPedCombatAttributes(Ped, 5, true);
				  --SetPedCombatAttributes(Ped, 1, false);
				  --SetPedCombatAttributes(Ped, 0, false);
				  --SetPedCombatAbility(Ped, 0);
				
				  --SetPedRagdollBlockingFlags(Ped, 4);
				  --SetPedCanPlayAmbientAnims(Ped, false);	
				  -- SetAmbientVoiceName(Ped,"ALIENS")
				   --DisablePedPainAudio(Ped,true)
				  -- RequestAnimSet("move_m@drunk@verydrunk");
				   --SetPedMovementClipset(Ped, "move_m@drunk@verydrunk",1.0);				
				
				else 
					SetPedCombatAttributes(Ped, 5, true)
					SetPedCombatAttributes(Ped, 46, true);
					SetPedCombatAttributes(Ped, 0, false);
					--SetPedCombatAttributes(Ped, 1, true) --can use vehicles
				end

			
				--1 in 5 chance of spawning a  hostagePedsKilledByPlayer
			
				if not spawnFriendly then
					SetPedRelationshipGroupHash(Ped, GetHashKey("HATES_PLAYER"))
					SetRelationshipBetweenGroups(5, GetHashKey("HATES_PLAYER"), GetHashKey("PLAYER"))
					SetRelationshipBetweenGroups(0, GetHashKey("HATES_PLAYER"), GetHashKey("HATES_PLAYER"))
				else 
					SetPedRelationshipGroupHash(Ped, GetHashKey("HOSTAGES"))
					SetRelationshipBetweenGroups(1, GetHashKey("HOSTAGES"), GetHashKey("HATES_PLAYER"))
					SetRelationshipBetweenGroups(1, GetHashKey("HOSTAGES"), GetHashKey("PLAYER"))
				end
				
				--they will combat but also try and keep to the task
				if getMissionConfigProperty(input, "IsDefend") and math.random(1,2)>1 then 
					DecorSetInt(Ped,"mrppedconqueror",i)
					--print('spawned Ped attacker')
				end 
			
			else
			
				-- is there a better way to make an NPC true neutral?
				--does not handle custom groups from other resources
				SetPedFleeAttributes(Ped, 0, 0)
				SetPedRelationshipGroupHash(Ped, GetHashKey("TRUENEUTRAL"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("PLAYER"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("HATES_PLAYER"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("HOSTAGES"))
				
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("CIVMALE"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("CIVFEMALE"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("COP"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SECURITY_GUARD"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("PRIVATE_SECURITY"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("FIREMAN"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_1"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_2"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_9"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_10"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_LOST"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_MEXICAN"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_FAMILY"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_BALLAS"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_MARABUNTE"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_CULT"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_SALVA"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_WEICHENG"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_HILLBILLY"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("DEALER"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("WILD_ANIMAL"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SHARK"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("HATES_PLAYER"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("COUGAR"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("NO_RELATIONSHIP"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SPECIAL"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION2"))		
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("NO_RELATIONSHIP"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SPECIAL"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION2"))			
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION3"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION4"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION5"))			
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION6"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION7"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION8"))			
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("ARMY"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GUARD_DOG"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AGGRESSIVE_INVESTIGATE"))						
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MEDIC"))
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("PRISONER"))	
				SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("DOMESTIC_ANIMAL"))	
				
				DecorSetInt(Ped,"mrppedconqueror",i)
				--print('spawned Ped Conqueror')
			
			end
			--SetEntityAsMissionEntity(Ped,true,true)
			SetPedSeeingRange(Ped, 10000.0)
			SetPedHearingRange(Ped, 10000.0)

			--SetEntityAsMissionEntity(Ped,true,true)
			DecorSetInt(Ped,"mrppedid",i)
			
			--if Config.Missions[input].Peds[i].invincible then
				--SetEntityInvincible(Ped, true)
			--end
			
			--if Config.Missions[input].Peds[i].dead then
				--SetEntityHealth(Ped, 0.0)
			--end					
			
			
			SetPedDropsWeaponsWhenDead(Ped, false)
			SetPedDiesWhenInjured(Ped, true)
		  
			GiveWeaponToPed(Ped, randomPedWeapon, 2800, false, true)
			ResetAiWeaponDamageModifier()
			if randomPedModelHash  == "mp_m_boatstaff_01" then --L. Ron
				SetPedPropIndex(Ped, 0, 0, 0, 2)
				--SetPedPropIndex(Ped, 0, 8, 0, 2) 
			end 
			--if Config.Missions[input].Peds[i].invincible then
				--SetEntityInvincible(Ped, true)
			--end
			
			--1 in 5 chance of dead friendly
			--except when HostageRescue is on
			if spawnFriendly and math.random(5) > 4 and not getMissionConfigProperty(input, "HostageRescue") then
				ApplyDamageToPed(Ped,90,true)
				SetEntityHealth(Ped, 0.0)
			end				
			
			--50% chance of wandering in area
			if math.random(2) > 1 and not spawnFriendly then
				--TaskWanderStandard(Ped,10.0, 10)
				TaskWanderInArea(Ped, rXoffset, rYoffset, rZoffset,spawnRadius,0.0,0.0)
			end		
			
			--local pedb = AddBlipForEntity(Ped)
			--local Size     = 0.9
			--SetBlipScale  (pedb, Size)
			--SetBlipAsShortRange(pedb, false)
			
			if spawnFriendly then --if ped is a target in assassinate
				--SetBlipColour(ped, 66)
				TaskCower(Ped,360000) -- 1hour
				--SetBlipSprite(pedb, 280)
				--SetBlipColour(pedb, 2)
				--BeginTextCommandSetBlipName("STRING")
				--AddTextComponentString("Friend ($-"..getHostageKillPenalty(input)..")")
				--EndTextCommandSetBlipName(pedb)									
				DecorSetInt(Ped,"mrppedfriend",i)
				--print("spawned a friendly")
			elseif MissionType=="Assassinate" then --if ped is a target in assassinate
				--SetBlipColour(ped, 66)
				--SetBlipSprite(pedb, 433)
				--SetBlipColour(pedb, 27)
				--BeginTextCommandSetBlipName("STRING")
				--AddTextComponentString("Target ($"..getTargetKillReward(input)..")")
				--EndTextCommandSetBlipName(pedb)						
				DecorSetInt(Ped,"mrppedtarget",i)
			else
				--BeginTextCommandSetBlipName("STRING")
				--AddTextComponentString("Enemy ($"..getKillReward(input)..")")
				--EndTextCommandSetBlipName(pedb)								
			end

			local movespeed = 10.0 --How fast can peds move?
			--everyone including friendlies move toward target, Marker's center
			if Config.Missions[input].IsDefend  then 
				ClearPedTasksImmediately(Ped)
				TaskGoStraightToCoord(Ped,Config.Missions[input].Marker.Position.x, Config.Missions[input].Marker.Position.y,Config.Missions[input].Marker.Position.z, movespeed, 100000, 0.0, 0.0) 
				SetPedKeepTask(Ped,true) 
			end		
			

			--if Config.Missions[input].Peds[i].armor then --if ped has armor
				AddArmourToPed(Ped, 100) --<**is 100 max for npc???**
				SetPedArmour(Ped, 100)
			--end				
			--blip = GetBlipFromEntity(pedb)
			
			SetAiWeaponDamageModifier(1.0) -- 1.0 == Normal Damage. 
			if (randomPedModelHash == "U_M_Y_Zombie_01" or randomPedModelHash == "S_M_M_MovAlien_01" or randomPedModelHash == "IG_Orleans") then --movie zed
				SetAiMeleeWeaponDamageModifier(50.0)
			else 
				SetAiMeleeWeaponDamageModifier(1.0)
			end 
			-- ^ Sets Custom NPC Damage. ^
		end
    end
	
	--GHK TEST
    for i=1, NumVehicles do
		
		--how rare are vehicles?
		if  getMissionConfigProperty(input, "RandomMissionChanceToSpawnVehiclePerTry")  >= math.random(100) then 
	
			local randomPedModelHash = getMissionConfigProperty(input, "RandomMissionPeds")[math.random(1, #getMissionConfigProperty(input, "RandomMissionPeds"))]
			local randomPedWeaponHash = getMissionConfigProperty(input, "RandomMissionWeapons")[math.random(1, #getMissionConfigProperty(input, "RandomMissionWeapons"))]
			local randomPedVehicleHash = getMissionConfigProperty(input, "RandomMissionVehicles")[math.random(1, #getMissionConfigProperty(input, "RandomMissionVehicles"))]
			local randomPedAircraftHash = getMissionConfigProperty(input, "RandomMissionAircraft")[math.random(1, #getMissionConfigProperty(input, "RandomMissionAircraft"))]
			local Ped
			local PedVehicle
			local spawnFriendly = false
			local spawnAircraft = 0
			
			--if math.random(5) > 4 then 
			--	spawnFriendly = true
			--	randomPedModelHash = Config.RandomMissionFriendlies [math.random(1, #Config.RandomMissionFriendlies )]
			--end

			--chance of spawning an Aircraft
			if getMissionConfigProperty(input, "RandomMissionAircraftChance") >= math.random(100) then 
				
				spawnAircraft = math.random(200,500) --use this for z altitude spawn OK for most planes, 747 jets dont work
				randomPedVehicleHash = randomPedAircraftHash
			end 			
		
			veh         =  randomPedVehicleHash
			
			vehiclehash = GetHashKey(veh)
			RequestModel(vehiclehash)
			RequestModel(randomPedModelHash)
			while not HasModelLoaded(vehiclehash) do
			  Wait(1)
			end
			
			local raytestsuccess = true
			local checkthisspawn = false
			--local _unused
			local spawnRadius = getMissionConfigProperty(input, "RandomMissionSpawnRadius")
			rXoffset = randomLocation.x + roundToNthDecimal(math.random() + math.random(-1*spawnRadius,spawnRadius - 1),4)
			
			rYoffset = randomLocation.y + roundToNthDecimal(math.random() + math.random(-1*spawnRadius,spawnRadius - 1),4)
			
			--_unused, rZoffset = GetGroundZFor_3dCoord(rXoffset, rYoffset, randomLocation.z) 
			
			--print("SPAWNPEDRANDOMVEH")
		
		
			if not randomLocation.force then --force is on, means we are OK to not check. 
				--print("FORCE OFF")
				--if spawnAircraft == 0 then --Also dont check for aircraft, they spawn + 200 above
					rZoffset = checkAndGetGroundZ(rXoffset, rYoffset,randomLocation.z,false) --LAST ARG: blFindGroundZ 
					if rZoffset == 0.0 then --flag for checkspawn
						checkspawns = true --global for all clients and mission
						checkthisspawn=true
						rZoffset = randomLocation.z   --***SPAWN AT THE DEFAULT Z POSITION? YES It will be corrected later
						--print("NOT AIRCRAFT")
					end
				--else 
				--print("AIRCRAFT")
					--rZoffset = randomLocation.z
				--end
			else 
				--print("FORCE ON")
				rZoffset = randomLocation.z
			end 
			
			--print("rZoffset:"..rZoffset)
			--print("checkthisspawn:"..tostring(checkthisspawn))
			--print("checkspawns:"..tostring(checkspawns))
			
			rHeading = roundToNthDecimal(math.random() + math.random(0,359),2)
			
			if not randomLocation.force then 
				--if spawnAircraft == 0 then --Also dont check for aircraft, they spawn + 200 above
					local ray = Citizen.InvokeNative( 0x377906D8A31E5586, vector3(rXoffset, rYoffset, rZoffset) + vector3(0.0, 0.0, 1000.0), vector3(rXoffset, rYoffset, rZoffset), -1, -1, 0)
					--local ray = StartShapeTestRay(vector3(rXoffset, rYoffset, rZoffset) + vector3(0.0, 0.0, 500.0), vector3(rXoffset, rYoffset, rZoffset), -1, -1, 0)
					-- local _, hit, impactCoords  = Citizen.InvokeNative( 0x3D87450E15D98694, ray,hit)
					local _, hit, impactCoords = GetRaycastResult(ray) --GetShapeTesResult(ray)
					-- print("HIT: " .. hit)
					-- print(("IMPACT COORDS: X = %.4f; Y = %.4f; Z = %.4f"):format(impactCoords.x, impactCoords.y, impactCoords.z))
					-- print("DISTANCE BETWEEN DROP AND IMPACT COORDS: " ..  #(vector3(dropCoords.x, dropCoords.y, dropCoords.z) - vector3(impactCoords)))
					if hit == 0 or (hit == 1 and #(vector3(rXoffset, rYoffset, rZoffset) - vector3(impactCoords)) < 0.5) then -- ± 0.5 units
						--print("ROOFCHECK: vehicle success")
						raytestsuccess = true
					else
						--print("ROOFCHECK: vehicles fail")
						raytestsuccess = false
				   
					end	
				--end
			end
			
			if raytestsuccess then 
	 
				PedVehicle = CreateVehicle(vehiclehash, rXoffset, rYoffset, rZoffset + spawnAircraft,  rHeading, 1, 0)
				
				
				--DoesEntityExist check here?
				if checkthisspawn then 
					--print('VEHICLECHECKTHISSPAWN')
					DecorSetInt(PedVehicle,"mrpcheckspawn",1) --flag Vehicle to be checked to readjust if necessary later 
				else 
					DecorSetInt(PedVehicle,"mrpcheckspawn",0)
				end
				
				SetEntityAsMissionEntity(PedVehicle,true,true)
				
				DecorSetInt(PedVehicle,"mrpvehdid",i)
				if randomPedModelHash ~=nil then 
					while not HasModelLoaded(randomPedModelHash) do
						Wait(1)
					end
					Ped = CreatePed(2, randomPedModelHash, rXoffset, rYoffset,rZoffset, rHeading, true, true)
					
					if(randomPedModelHash  == "s_m_m_movalien_01") then
						SetPedDefaultComponentVariation(Ped) --GHK for s_m_m_movalien_01
					end
					
					SetEntityAsMissionEntity(Ped,true,true)
					
					DecorSetInt(Ped,"mrpvpedid",i)
					
					--make all vehicle drivers TRUENUTRAL 'Conqueror' NPCs, so they make a beeline to the Marker
					if not getMissionConfigProperty(input, "IsDefend") then 
						
						
						SetPedRelationshipGroupHash(Ped, GetHashKey("HATES_PLAYER"))
						SetRelationshipBetweenGroups(5, GetHashKey("HATES_PLAYER"), GetHashKey("PLAYER"))
						SetRelationshipBetweenGroups(0, GetHashKey("HATES_PLAYER"), GetHashKey("HATES_PLAYER"))
							
						
						if MissionType == "Assassination" then 
								--50% chance to flee
							if math.random(2) > 1  then --flee
								
								
								SetPedFleeAttributes(Ped, 0, 0)
								SetPedCombatAttributes(Ped, 5, true)	
								SetPedCombatAttributes(Ped, 16, true)
								SetPedCombatAttributes(Ped, 46, true)
								SetPedCombatAttributes(Ped, 26, true)
							
							
							end 
							
						else 
							SetPedFleeAttributes(Ped, 0, 0)
							SetPedCombatAttributes(Ped, 5, true)	
							SetPedCombatAttributes(Ped, 16, true)
							SetPedCombatAttributes(Ped, 46, true)
							SetPedCombatAttributes(Ped, 26, true)
							
						end	
						SetPedCombatAttributes(Ped, 3, false)
						SetPedCombatAttributes(Ped, 2, true)
						
					else 
					
						-- is there a better way to make an NPC true neutral?
						--does not handle custom groups from other resources
						SetPedFleeAttributes(Ped, 0, 0)
						SetPedRelationshipGroupHash(Ped, GetHashKey("TRUENEUTRAL"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("PLAYER"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("HATES_PLAYER"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("HOSTAGES"))
						
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("CIVMALE"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("CIVFEMALE"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("COP"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SECURITY_GUARD"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("PRIVATE_SECURITY"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("FIREMAN"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_1"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_2"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_9"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_10"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_LOST"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_MEXICAN"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_FAMILY"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_BALLAS"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_MARABUNTE"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_CULT"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_SALVA"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_WEICHENG"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_HILLBILLY"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("DEALER"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("WILD_ANIMAL"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SHARK"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("HATES_PLAYER"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("COUGAR"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("NO_RELATIONSHIP"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SPECIAL"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION2"))		
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("NO_RELATIONSHIP"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SPECIAL"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION2"))			
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION3"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION4"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION5"))			
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION6"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION7"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION8"))			
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("ARMY"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GUARD_DOG"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AGGRESSIVE_INVESTIGATE"))						
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MEDIC"))
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("PRISONER"))	
						SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("DOMESTIC_ANIMAL"))	
				
					
					end 	
						
					 SetPedSeeingRange(Ped, 10000.0)
					 SetPedHearingRange(Ped, 10000.0)		
					
					SetPedDropsWeaponsWhenDead(Ped, false)
					SetPedDiesWhenInjured(Ped, true)
					
					--GIVE WEAPONS TO PED DRIVERS
					GiveWeaponToPed(Ped, randomPedWeaponHash, 2800, false, true)
					
					ResetAiWeaponDamageModifier()
					SetPedIntoVehicle(Ped, PedVehicle, -1)
					
					--if Config.Missions[input].Vehicles[i].invincible then
						--SetEntityInvincible(Ped, true)
					--end
					
					--if Config.Missions[input].Vehicles[i].dead then
						--SetEntityHealth(Ped, 0.0)
						
					--end							
					
					---**Just Driver Ped**
					--ExtraPeds
					--if Config.Missions[input].Vehicles[i].ExtraPeds then
				
						--for j, v in pairs(Config.Missions[input].Vehicles[i].ExtraPeds) do
				
							--SetPedIntoVehicle(Config.Missions[input].Peds[v.id].id, PedVehicle, v.seatid)
						--end
					
					--end 	
					
					--50% to be driving, unless a plane, so always drives
					if math.random(2) > 1 or spawnAircraft > 0  then
							--if Config.Missions[input].Vehicles[i].movespeed ~= nil then

								--TaskVehicleDriveWander(Ped, GetVehiclePedIsIn(Ped, false), Config.Missions[input].Vehicles[i].movespeed, 0)
							--else
						
						TaskVehicleDriveWander(Ped, GetVehiclePedIsIn(Ped, false), 20.0, 0)
							--end
						
							--else 
							--TaskVehicleFollow(Ped, GetVehiclePedIsIn(Ped, false), GetPlayerPed(-1), 0, 20.0, 5)
					end
					
					local movespeed =1200.0 --how fast can a vehicle go?
					
					if Config.Missions[input].IsDefend then -- and spawnAircraft  == 0 then ? --AIRCRAFT TOO?
						ClearPedTasksImmediately(Ped)
						TaskVehicleDriveToCoordLongrange(Ped,  GetVehiclePedIsIn(Ped, false), Config.Missions[input].Marker.Position.x, Config.Missions[input].Marker.Position.y,Config.Missions[input].Marker.Position.z, movespeed, 0, 0.0) --drive mode is zero
						SetPedKeepTask(Ped,true) 		
						--TaskVehicleFollow(Config.Missions[input].Vehicles[i].id2, GetVehiclePedIsIn(Config.Missions[input].Vehicles[i].id2, false), GetPlayerPed(-1), 0, 20.0, 5)
					end					
					
					
					--SetPedIntoVehicle(Config.Missions[input].Peds[1].id, PedVehicle, -2)
					--ped = AddBlipForEntity(PedVehicle)
					--Add blip to actual ped, not vehicles
					--local pedb = AddBlipForEntity(Ped)
					--target=true --<----??????
					--local Size     = 0.9
					--SetBlipScale(pedb, Size)
					--SetBlipAsShortRange(pedb, false)
					
					if spawnFriendly then --disabled
						--SetBlipSprite(pedb, 280)
						--SetBlipColour(pedb, 2)
						DecorSetInt(Ped,"mrppedfriend",i)
						--BeginTextCommandSetBlipName("STRING")
						--AddTextComponentString("Friend ($-"..getHostageKillPenalty(input)..")")
						--EndTextCommandSetBlipName(pedb)				        
					elseif MissionType=="Assassinate" then --if ped is a target in assassinate
						--SetBlipColour(ped, 66)
						--SetBlipSprite(pedb, 433)
						--SetBlipColour(pedb, 27)
						DecorSetInt(Ped,"mrppedtarget",i)
						--BeginTextCommandSetBlipName("STRING")
						--AddTextComponentString("Target ($"..getTargetKillReward(input)..")")
						--EndTextCommandSetBlipName(pedb)						
					else
					--	SetBlipColour(pedb, 1)
					--	BeginTextCommandSetBlipName("STRING")
					--	AddTextComponentString("Enemy ($"..getKillReward(input)..")")
					--	EndTextCommandSetBlipName(pedb)							
					
					end	

					--if Config.Missions[input].Vehicles[i].armor then --if ped has armor
						AddArmourToPed(Ped, 100)
						SetPedArmour(Ped, 100)
					--end						
					
					SetAiWeaponDamageModifier(1.0) -- 1.0 == Normal Damage. 
					-- ^ Sets Custom NPC Damage. ^
					
					--Now check if Vehicle has turrets and fill those positions...
					local randomPedWeaponHash = getMissionConfigProperty(input, "RandomMissionWeapons")[math.random(1, #getMissionConfigProperty(input, "RandomMissionWeapons"))]
					PutPedsIntoTurrets(PedVehicle,randomPedVehicleHash,randomPedModelHash,randomPedWeaponHash,MissionType)				
				end
			end
		end
    end
	if checkspawns then --tell other clients to check as well looking for the mrpcheckspawn decor value > 0
		TriggerServerEvent("sv:checkspawns",checkspawns)
	end 
	PedsSpawned = 1
    aliveCheck()
end)




RegisterNetEvent('SpawnPed')
AddEventHandler('SpawnPed', function(input)
	SpawnProps(input)
	--SpawnMissionPickups(input) --called in missionhb
    for i=1, #Config.Missions[input].Peds do
        RequestModel(GetHashKey(Config.Missions[input].Peds[i].modelHash))
        while not HasModelLoaded(GetHashKey(Config.Missions[input].Peds[i].modelHash)) do
          Wait(1)
        end
        Config.Missions[input].Peds[i].id = CreatePed(2, Config.Missions[input].Peds[i].modelHash, Config.Missions[input].Peds[i].x, Config.Missions[input].Peds[i].y, Config.Missions[input].Peds[i].z, Config.Missions[input].Peds[i].heading, true, true)
        
		if(Config.Missions[input].Peds[i].modelHash == "S_M_M_MovAlien_01") then
			SetPedDefaultComponentVariation(Config.Missions[input].Peds[i].id) --GHK for s_m_m_movalien_01
		end
		
		
		SetEntityAsMissionEntity(Config.Missions[input].Peds[i].id,true,true)
		
		--for IsDefend, they beeline to the objective
		if not Config.Missions[input].Peds[i].conqueror then 
			--use 'notzed' attribute to remove extra zombietype characteristics for these models
			if (Config.Missions[input].Peds[i].modelHash == "U_M_Y_Zombie_01" or Config.Missions[input].Peds[i].modelHash == "s_m_m_movalien_01" or Config.Missions[input].Peds[i].modelHash ==  "IG_Orleans") and not Config.Missions[input].Peds[i].notzed then  --or Config.Missions[input].Peds[i].modelHash ==  "IG_Orleans") then --movie zed
					SetPedFleeAttributes(Config.Missions[input].Peds[i].id, 0, 0)
					SetPedCombatAttributes(Config.Missions[input].Peds[i].id, 16, true)
					SetPedCombatAttributes(Config.Missions[input].Peds[i].id, 46, true)
					SetPedCombatAttributes(Config.Missions[input].Peds[i].id, 26, true)
					SetAmbientVoiceName(Config.Missions[input].Peds[i].id, "ALIENS")
					SetPedEnableWeaponBlocking(Config.Missions[input].Peds[i].id, true)			
					DisablePedPainAudio(Config.Missions[input].Peds[i].id,true)
					
				--if not Config.Missions[input].Peds[i].modelHash == "IG_Orleans" then
					ApplyPedBlood(Config.Missions[input].Peds[i].id, 3, math.random(0, 4) + 0.0, math.random(-0, 4) + 0.0, math.random(-0, 4) + 0.0, "wound_sheet")
					SetPedIsDrunk(Config.Missions[input].Peds[i].id, true)
					RequestAnimSet("move_m@drunk@verydrunk")
					while not HasAnimSetLoaded("move_m@drunk@verydrunk") do
						Wait(1)
					end
					SetPedMovementClipset(Config.Missions[input].Peds[i].id, "move_m@drunk@verydrunk", 1.0)						
				--end		
					
				--SetPedCombatRange(Config.Missions[input].Peds[i].id, 2)
			  --	SetPedSeeingRange(Config.Missions[input].Peds[i].id, 100000000.0)
				--SetPedHearingRange(Config.Missions[input].Peds[i].id, 100000000.0)
			  --SetPedCombatAttributes(Config.Missions[input].Peds[i].id, 46, true);
			 -- SetPedCombatAttributes(Config.Missions[input].Peds[i].id, 5, true);
			  --SetPedCombatAttributes(Config.Missions[input].Peds[i].id, 1, false);
			  --SetPedCombatAttributes(Config.Missions[input].Peds[i].id, 0, false);
			  --SetPedCombatAbility(Config.Missions[input].Peds[i].id, 0);
			
			  --SetPedRagdollBlockingFlags(Config.Missions[input].Peds[i].id, 4);
			  --SetPedCanPlayAmbientAnims(Config.Missions[input].Peds[i].id, false);	
			  -- SetAmbientVoiceName(Config.Missions[input].Peds[i].id,"ALIENS")
			   --DisablePedPainAudio(Config.Missions[input].Peds[i].id,true)
			  -- RequestAnimSet("move_m@drunk@verydrunk");
			   --SetPedMovementClipset(Config.Missions[input].Peds[i].id, "move_m@drunk@verydrunk",1.0);				
			else 
				SetPedCombatAttributes(Config.Missions[input].Peds[i].id, 5, true)
				SetPedCombatAttributes(Config.Missions[input].Peds[i].id, 46, true);
				SetPedCombatAttributes(Config.Missions[input].Peds[i].id, 0, false);
				SetPedCombatAttributes(Config.Missions[input].Peds[i].id, 2, true)
			end
		
			if not Config.Missions[input].Peds[i].friendly then
				SetPedRelationshipGroupHash(Config.Missions[input].Peds[i].id, GetHashKey("HATES_PLAYER"))
				SetRelationshipBetweenGroups(5, GetHashKey("HATES_PLAYER"), GetHashKey("PLAYER"))
				SetRelationshipBetweenGroups(0, GetHashKey("HATES_PLAYER"), GetHashKey("HATES_PLAYER"))
			else 
				SetPedRelationshipGroupHash(Config.Missions[input].Peds[i].id, GetHashKey("HOSTAGES"))
				SetRelationshipBetweenGroups(1, GetHashKey("HOSTAGES"), GetHashKey("HATES_PLAYER"))
				SetRelationshipBetweenGroups(1, GetHashKey("HOSTAGES"), GetHashKey("PLAYER"))
			end
			
		else  
			-- is there a better way to make an NPC true neutral?
			--does not handle custom groups from other resources
			SetPedFleeAttributes(Config.Missions[input].Peds[i].id, 0, 0)
			SetPedRelationshipGroupHash(Config.Missions[input].Peds[i].id, GetHashKey("TRUENEUTRAL"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("PLAYER"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("HATES_PLAYER"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("HOSTAGES"))
			
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("CIVMALE"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("CIVFEMALE"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("COP"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SECURITY_GUARD"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("PRIVATE_SECURITY"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("FIREMAN"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_1"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_2"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_9"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_10"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_LOST"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_MEXICAN"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_FAMILY"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_BALLAS"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_MARABUNTE"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_CULT"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_SALVA"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_WEICHENG"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_HILLBILLY"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("DEALER"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("WILD_ANIMAL"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SHARK"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("HATES_PLAYER"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("COUGAR"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("NO_RELATIONSHIP"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SPECIAL"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION2"))		
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("NO_RELATIONSHIP"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SPECIAL"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION2"))			
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION3"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION4"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION5"))			
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION6"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION7"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION8"))			
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("ARMY"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GUARD_DOG"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AGGRESSIVE_INVESTIGATE"))						
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MEDIC"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("PRISONER"))	
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("DOMESTIC_ANIMAL"))	
			
			DecorSetInt(Config.Missions[input].Peds[i].id,"mrppedconqueror",i)
			--print('spawned Ped Conqueror')
			
		end
		
		--they weill combat but also try and keep to the task
		if Config.Missions[input].Peds[i].attacker then 
			DecorSetInt(Config.Missions[input].Peds[i].id,"mrppedconqueror",i)
		end
		
		--SetEntityAsMissionEntity(Config.Missions[input].Peds[i].id,true,true)
		 SetPedSeeingRange(Config.Missions[input].Peds[i].id, 10000.0)
         SetPedHearingRange(Config.Missions[input].Peds[i].id, 10000.0)

		--SetEntityAsMissionEntity(Config.Missions[input].Peds[i].id,true,true)
		DecorSetInt(Config.Missions[input].Peds[i].id,"mrppedid",i)
		
		
        SetPedDropsWeaponsWhenDead(Config.Missions[input].Peds[i].id, false)
        SetPedDiesWhenInjured(Config.Missions[input].Peds[i].id, true)
        
		GiveWeaponToPed(Config.Missions[input].Peds[i].id, Config.Missions[input].Peds[i].Weapon, 2800, false, true)
        ResetAiWeaponDamageModifier()
		if Config.Missions[input].Peds[i].modelHash == "mp_m_boatstaff_01" then --L. Ron
			SetPedPropIndex(Config.Missions[input].Peds[i].id, 0, 0, 0, 2)
			--SetPedPropIndex(Config.Missions[input].Peds[i].id, 0, 8, 0, 2) 
		end 
		if Config.Missions[input].Peds[i].invincible then
			SetEntityInvincible(Config.Missions[input].Peds[i].id, true)
		end
		
		if Config.Missions[input].Peds[i].dead then
			--ApplyDamageToPed(Config.Missions[input].Peds[i].id,90,true)
			SetEntityHealth(Config.Missions[input].Peds[i].id, 0.0)
			
		end				
		
		if Config.Missions[input].Peds[i].wander then
			TaskWanderStandard(Config.Missions[input].Peds[i].id,10.0, 10)
		elseif Config.Missions[input].Peds[i].wanderinarea then
			TaskWanderInArea(Config.Missions[input].Peds[i].id,Config.Missions[input].Peds[i].x,Config.Missions[input].Peds[i].y,Config.Missions[input].Peds[i].z,25.0,0.0,0.0) --wanderinarea within 25 meters 
		end		
		
      --  local ped = AddBlipForEntity(Config.Missions[input].Peds[i].id)
      --  local Size     = 0.9
      --  SetBlipScale  (ped, Size)
      --  SetBlipAsShortRange(ped, false)
		
		if Config.Missions[input].Peds[i].friendly then 
			TaskCower(Config.Missions[input].Peds[i].id,360000) -- 1hour
			--SetBlipColour(ped, 66)
			--SetBlipSprite(ped, 280)
		--	SetBlipColour(ped, 2)
			--BeginTextCommandSetBlipName("STRING")
			--AddTextComponentString("Friend ($-"..getHostageKillPenalty(input)..")")
			--EndTextCommandSetBlipName(ped)									
			DecorSetInt(Config.Missions[input].Peds[i].id,"mrppedfriend",i)
		elseif Config.Missions[input].Peds[i].target then --if ped is a target in assassinate
			--SetBlipColour(ped, 66)
			--SetBlipSprite(ped, 433)
			--SetBlipColour(ped, 27)
			--BeginTextCommandSetBlipName("STRING")
			--AddTextComponentString("Target ($"..getTargetKillReward(input)..")")
			--EndTextCommandSetBlipName(ped)						
			DecorSetInt(Config.Missions[input].Peds[i].id,"mrppedtarget",i)
		else
		--	BeginTextCommandSetBlipName("STRING")
		--	AddTextComponentString("Enemy ($"..getKillReward(input)..")")
		--	EndTextCommandSetBlipName(ped)								
		end	
		
		
		local movespeed = 5.0 --How fast can peds move?
		if(Config.Missions[input].Peds[i]) then 
			if Config.Missions[input].Peds[i].movespeed ~= nil then
				movespeed = Config.Missions[input].Peds[i].movespeed
			end				
		end 
		--conqueror bee-lines to objective and is neutral, attacker will combat
		--everyone, friendlies as well move
		if Config.Missions[input].IsDefend  then 
			ClearPedTasksImmediately(Config.Missions[input].Peds[i].id)
			TaskGoStraightToCoord(Config.Missions[input].Peds[i].id,Config.Missions[input].Marker.Position.x, Config.Missions[input].Marker.Position.y,Config.Missions[input].Marker.Position.z, movespeed, 100000, 0.0, 0.0) 
			SetPedKeepTask(Config.Missions[input].Vehicles[i].id2,true) 
		end		

		--override everything with movetocoord
		if Config.Missions[input].Peds[i].movetocoord then 
			ClearPedTasksImmediately(Config.Missions[input].Peds[i].id)
			TaskGoStraightToCoord(Config.Missions[input].Peds[i].id,Config.Missions[input].Peds[i].movetocoord.x, Config.Missions[input].Peds[i].movetocoord.y,Config.Missions[input].Peds[i].movetocoord.y, movespeed, 100000, 0.0, 0.0) 
			SetPedKeepTask(Config.Missions[input].Vehicles[i].id2,true) 
		end			
		
		if Config.Missions[input].Peds[i].armor then --if ped has armor
			AddArmourToPed(Config.Missions[input].Peds[i].id, Config.Missions[input].Peds[i].armor)
			SetPedArmour(Config.Missions[input].Peds[i].id, Config.Missions[input].Peds[i].armor)
		end				
       -- blip = GetBlipFromEntity(ped)
		
        SetAiWeaponDamageModifier(1.0) -- 1.0 == Normal Damage. 
		
		--use 'notzed' attribute to remove extra zombietype characteristics for these models
		if (Config.Missions[input].Peds[i].modelHash == "U_M_Y_Zombie_01" or Config.Missions[input].Peds[i].modelHash == "S_M_M_MovAlien_01" or Config.Missions[input].Peds[i].modelHash == "IG_Orleans") and not Config.Missions[input].Peds[i].notzed then --movie zed
			SetAiMeleeWeaponDamageModifier(50.0)
		else 
			SetAiMeleeWeaponDamageModifier(1.0)
		end 
        -- ^ Sets Custom NPC Damage. ^
    end
    for i=1, #Config.Missions[input].Vehicles do
        veh         =  Config.Missions[input].Vehicles[i].Vehicle
        vehiclehash = GetHashKey(veh)
        RequestModel(vehiclehash)
        RequestModel(GetHashKey(Config.Missions[input].Vehicles[i].modelHash))
        while not HasModelLoaded(vehiclehash) do
          Wait(1)
        end
 
        Config.Missions[input].Vehicles[i].id = CreateVehicle(vehiclehash, Config.Missions[input].Vehicles[i].x, Config.Missions[input].Vehicles[i].y, Config.Missions[input].Vehicles[i].z,  Config.Missions[input].Vehicles[i].heading, 1, 0)
		DecorSetInt(Config.Missions[input].Vehicles[i].id,"mrpvehdid",i)
		if Config.Missions[input].Vehicles[i].id2 ~=nil then 
			while not HasModelLoaded(GetHashKey(Config.Missions[input].Vehicles[i].modelHash)) do
				Wait(1)
			end
			Config.Missions[input].Vehicles[i].id2 = CreatePed(2, Config.Missions[input].Vehicles[i].modelHash, Config.Missions[input].Vehicles[i].x, Config.Missions[input].Vehicles[i].y, Config.Missions[input].Vehicles[i].z, Config.Missions[input].Vehicles[i].heading, true, true)
			
			if(Config.Missions[input].Vehicles[i].modelHash == "s_m_m_movalien_01") then
				SetPedDefaultComponentVariation(Config.Missions[input].Vehicles[i].id2) --GHK for s_m_m_movalien_01
			end
			
			SetEntityAsMissionEntity(Config.Missions[input].Vehicles[i].id,true,true)
			SetEntityAsMissionEntity(Config.Missions[input].Peds[i].id2,true,true)
			
			DecorSetInt(Config.Missions[input].Vehicles[i].id2,"mrpvpedid",i)
			
			
			--for IsDefend, they beeline to the objective
			if not Config.Missions[input].Vehicles[i].conqueror then 
				if not Config.Missions[input].Vehicles[i].friendly then
					--if not Config.Missions[input].Vehicles[i].pilot then 
						SetPedRelationshipGroupHash(Config.Missions[input].Vehicles[i].id2, GetHashKey("HATES_PLAYER"))
						SetRelationshipBetweenGroups(5, GetHashKey("HATES_PLAYER"), GetHashKey("PLAYER"))
						SetRelationshipBetweenGroups(0, GetHashKey("HATES_PLAYER"), GetHashKey("HATES_PLAYER"))
					
					--end
					if not Config.Missions[input].Vehicles[i].flee then --and not Config.Missions[input].Vehicles[i].pilot then 
						SetPedFleeAttributes(Config.Missions[input].Vehicles[i].id2, 0, 0)
						SetPedCombatAttributes(Config.Missions[input].Vehicles[i].id2, 3, false)
						SetPedCombatAttributes(Config.Missions[input].Vehicles[i].id2, 16, true)
						SetPedCombatAttributes(Config.Missions[input].Vehicles[i].id2, 46, true)
						SetPedCombatAttributes(Config.Missions[input].Vehicles[i].id2, 26, true)
					end 
				else 
					SetPedRelationshipGroupHash(Config.Missions[input].Vehicles[i].id2, GetHashKey("HOSTAGES"))
					SetRelationshipBetweenGroups(1, GetHashKey("HOSTAGES"), GetHashKey("HATES_PLAYER"))
					SetRelationshipBetweenGroups(1, GetHashKey("HOSTAGES"), GetHashKey("PLAYER"))			
					--SetPedRelationshipGroupHash(Config.Missions[input].Vehicles[i].id2, GetHashKey("NO_RELATIONSHIP"))
				end	
				SetPedCombatAttributes(Config.Missions[input].Vehicles[i].id2, 2, true)
				SetPedCombatAttributes(Config.Missions[input].Vehicles[i].id2, 3, false)	
				SetPedSeeingRange(Config.Missions[input].Vehicles[i].id2, 10000.0)
				SetPedHearingRange(Config.Missions[input].Vehicles[i].id2, 10000.0)	
			else 
			-- is there a better way to make an NPC true neutral?
			--does not handle custom groups from other resources
			SetPedFleeAttributes(Config.Missions[input].Vehicles[i].id2, 0, 0)
			SetPedRelationshipGroupHash(Config.Missions[input].Vehicles[i].id2, GetHashKey("TRUENEUTRAL"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("PLAYER"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("HATES_PLAYER"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("HOSTAGES"))
			
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("CIVMALE"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("CIVFEMALE"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("COP"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SECURITY_GUARD"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("PRIVATE_SECURITY"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("FIREMAN"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_1"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_2"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_9"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GANG_10"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_LOST"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_MEXICAN"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_FAMILY"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_BALLAS"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_MARABUNTE"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_CULT"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_SALVA"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_WEICHENG"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AMBIENT_GANG_HILLBILLY"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("DEALER"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("WILD_ANIMAL"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SHARK"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("HATES_PLAYER"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("COUGAR"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("NO_RELATIONSHIP"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SPECIAL"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION2"))		
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("NO_RELATIONSHIP"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("SPECIAL"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION2"))			
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION3"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION4"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION5"))			
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION6"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION7"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MISSION8"))			
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("ARMY"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("GUARD_DOG"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("AGGRESSIVE_INVESTIGATE"))						
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("MEDIC"))
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("PRISONER"))	
			SetRelationshipBetweenGroups(0, GetHashKey("TRUENEUTRAL"), GetHashKey("DOMESTIC_ANIMAL"))			
			
			--print('VEH PED IS CONQUEROR')
		
		end
			
			
			
			SetPedDropsWeaponsWhenDead(Config.Missions[input].Vehicles[i].id2, false)
			SetPedDiesWhenInjured(Config.Missions[input].Vehicles[i].id2, true)
			GiveWeaponToPed(Config.Missions[input].Vehicles[i].id2, Config.Missions[input].Vehicles[i].Weapon, 2800, false, true)
			ResetAiWeaponDamageModifier()
			SetPedIntoVehicle(Config.Missions[input].Vehicles[i].id2, Config.Missions[input].Vehicles[i].id, -1)
			
			if Config.Missions[input].Vehicles[i].invincible then
				SetEntityInvincible(Config.Missions[input].Vehicles[i].id2, true)
			end
			
			if Config.Missions[input].Vehicles[i].dead then
				--ApplyDamageToPed(Config.Missions[input].Peds[i].id,90,true)
				SetEntityHealth(Config.Missions[input].Vehicles[i].id2, 0.0)
				
			end							
			
			--ExtraPeds
			if Config.Missions[input].Vehicles[i].ExtraPeds then
		
				for j, v in pairs(Config.Missions[input].Vehicles[i].ExtraPeds) do
		
					SetPedIntoVehicle(Config.Missions[input].Peds[v.id].id, Config.Missions[input].Vehicles[i].id, v.seatid)
				end
			
			end
			
			local movespeed = 20.0 
			if Config.Missions[input].Vehicles[i] then
				if Config.Missions[input].Vehicles[i].movespeed ~= nil then
				 movespeed = Config.Missions[input].Vehicles[i].movespeed
				end		
			end

			if Config.Missions[input].Vehicles[i].driving then
				
				TaskVehicleDriveWander(Config.Missions[input].Vehicles[i].id2, GetVehiclePedIsIn(Config.Missions[input].Vehicles[i].id2, false), movespeed, 0)
			
			elseif Config.Missions[input].Vehicles[i].movetocoord then 
				TaskVehicleDriveToCoordLongrange(Config.Missions[input].Vehicles[i].id2, Config.Missions[input].Vehicles[i].id, Config.Missions[input].Vehicles[i].movetocoord.x, Config.Missions[input].Vehicles[i].movetocoord.y,  Config.Missions[input].Vehicles[i].movetocoord.z, movespeed, 0, 5.0) --drive mode is zero
				SetPedKeepTask(Config.Missions[input].Vehicles[i].id2,true) 
			elseif Config.Missions[input].IsDefend then 
				TaskVehicleDriveToCoordLongrange(Config.Missions[input].Vehicles[i].id2, Config.Missions[input].Vehicles[i].id, Config.Missions[input].Marker.Position.x, Config.Missions[input].Marker.Position.y,Config.Missions[input].Marker.Position.z, movespeed, 0, 0.0) --drive mode is zero
				SetPedKeepTask(Config.Missions[input].Vehicles[i].id2,true) 		
			
				--TaskVehicleFollow(Config.Missions[input].Vehicles[i].id2, GetVehiclePedIsIn(Config.Missions[input].Vehicles[i].id2, false), GetPlayerPed(-1), 0, 20.0, 5)
			end
			--SetPedIntoVehicle(Config.Missions[input].Peds[1].id, Config.Missions[input].Vehicles[i].id, -2)
			--ped = AddBlipForEntity(Config.Missions[input].Vehicles[i].id)
			--Add blip to actual ped, not vehicles
			--local ped = AddBlipForEntity(Config.Missions[input].Vehicles[i].id2)
			--target=true --<----??????
			--local Size     = 0.9
			--SetBlipScale(ped, Size)
			--SetBlipAsShortRange(ped, false)
			--blip = GetBlipFromEntity(ped)
			--SetBlipSprite(blip, 58)
			if Config.Missions[input].Vehicles[i].friendly then
				--SetBlipSprite(ped, 280)
			--	SetBlipColour(ped, 2)
				DecorSetInt(Config.Missions[input].Vehicles[i].id2,"mrppedfriend",i)
			--	BeginTextCommandSetBlipName("STRING")
			--	AddTextComponentString("Friend ($-"..getHostageKillPenalty(input)..")")
			--	EndTextCommandSetBlipName(ped)				        
			elseif Config.Missions[input].Vehicles[i].target then --if ped is a target in assassinate
				--SetBlipColour(ped, 66)
				--SetBlipSprite(ped, 433)
			--	SetBlipColour(ped, 27)
				DecorSetInt(Config.Missions[input].Vehicles[i].id2,"mrppedtarget",i)
			--	BeginTextCommandSetBlipName("STRING")
			--	AddTextComponentString("Target ($"..getTargetKillReward(input)..")")
			--	EndTextCommandSetBlipName(ped)						
			else
			--	SetBlipColour(ped, 1)
			--	BeginTextCommandSetBlipName("STRING")
			--	AddTextComponentString("Enemy ($"..getKillReward(input)..")")
			--	EndTextCommandSetBlipName(ped)							
			
			end	

			if Config.Missions[input].Vehicles[i].armor then --if ped has armor
				AddArmourToPed(Config.Missions[input].Vehicles[i].id2, Config.Missions[input].Vehicles[i].armor)
				SetPedArmour(Config.Missions[input].Vehicles[i].id2, Config.Missions[input].Vehicles[i].armor)
			end						
			
			SetAiWeaponDamageModifier(1.0) -- 1.0 == Normal Damage. 
			-- ^ Sets Custom NPC Damage. ^
				--Now check if Vehicle has turrets and fill those positions...
				--SHOULD THIS EVEN BE CALLED IN SPAWNPEDS?, since ExtraPeds attribute can define this
			PutPedsIntoTurrets(Config.Missions[input].Vehicles[i].id,Config.Missions[input].Vehicles[i].Vehicle,Config.Missions[input].Vehicles[i].modelHash,Config.Missions[input].Vehicles[i].Weapon,Config.Missions[input].Type)
				
										
		end
    end
	PedsSpawned = 1
    aliveCheck()
end)

----FUNCTIONS



--Now in missions.lua
--[[local VehicleTurretSeatIds = {
	apc = {0},
	barrage = {1,2},
	halftrack = {1},
	dune3 = {0},
	insurgent = {7},
	insurgent3 = {7},
	technical = {1},
	technical2 = {1},
	technical3 = {1},
	limo2 = {3}
}
]]--

--checks if vehicle has a turret, how many, then puts 
--peds into them
function PutPedsIntoTurrets(PedVehicle,vehicleHash,modelHash,weaponHash,MissionType)
	if Config.VehicleTurretSeatIds[vehicleHash] then 
		for i, v in pairs(Config.VehicleTurretSeatIds[vehicleHash]) do

			--in SpawnPeds event, ExtraPeds might have these seats full
			--Should this function even be called in SpawnPeds, since ExtraPeds
			--can do this, and its more specific. 
			if modelHash ~=nil and IsVehicleSeatFree(PedVehicle, v) then 
				local Ped
				local coords = GetEntityCoords(vehicle)
				while not HasModelLoaded(modelHash) do
					Wait(1)
				end
				
				Ped = CreatePed(2, modelHash, coords.x, coords.y,coords.z, 180.0, true, true)
				
				
				if(modelHash  == "s_m_m_movalien_01") then
					SetPedDefaultComponentVariation(Ped) --GHK for s_m_m_movalien_01
				end
				
				SetEntityAsMissionEntity(Ped,true,true)
				 
				DecorSetInt(Ped,"mrpvpedid",1) --**Should not matter what value, as long as we set one**
				--if not Config.Missions[input].Vehicles[i].friendly then
					
				SetPedRelationshipGroupHash(Ped, GetHashKey("HATES_PLAYER"))
				SetRelationshipBetweenGroups(5, GetHashKey("HATES_PLAYER"), GetHashKey("PLAYER"))
				SetRelationshipBetweenGroups(0, GetHashKey("HATES_PLAYER"), GetHashKey("HATES_PLAYER"))
					
				
				if MissionType == "Assassination" then 
						--50% chance to flee
					if math.random(2) > 1  then --flee
					--No fleeing for turret guys
						--SetPedFleeAttributes(Ped, 0, 0)
						--SetPedCombatAttributes(Ped, 16, true)
						--SetPedCombatAttributes(Ped, 46, true)
						--SetPedCombatAttributes(Ped, 26, true)
					else
					SetPedFleeAttributes(Ped, 0, 0)
					--SetPedCombatAttributes(Ped, 3, false)
					SetPedCombatAttributes(Ped, 16, true)
					SetPedCombatAttributes(Ped, 46, true)
					SetPedCombatAttributes(Ped, 26, true)
										
				
					end 
					
				else 
					SetPedFleeAttributes(Ped, 0, 0)
					--SetPedCombatAttributes(Ped, 3, false)
					SetPedCombatAttributes(Ped, 16, true)
					SetPedCombatAttributes(Ped, 46, true)
					SetPedCombatAttributes(Ped, 26, true)
					
				end			
	
				SetPedCombatAttributes(Ped, 3, false);
				SetPedCombatAttributes(Ped, 2, true)
				 SetPedSeeingRange(Ped, 10000.0)
				 SetPedHearingRange(Ped, 10000.0)		
				
				SetPedDropsWeaponsWhenDead(Ped, false)
				SetPedDiesWhenInjured(Ped, true)
				
				--GIVE WEAPONS TO PED turret guys?
				GiveWeaponToPed(Ped, weaponHash, 2800, false, true)
				
				ResetAiWeaponDamageModifier()
				
				--**HERE IS WHERE THE TURRET GUY SITS**
				SetPedIntoVehicle(Ped, PedVehicle, v)
				
				--Add blip to actual ped, not vehicles
				--local pedb = AddBlipForEntity(Ped)
				--target=true --<----??????
				--local Size     = 0.9
				--SetBlipScale(pedb, Size)
				--SetBlipAsShortRange(pedb, false)
				
				spawnFriendly =false --no friendly turret guys
				if spawnFriendly then --disabled
					--SetBlipSprite(pedb, 280)
				--	SetBlipColour(pedb, 2)
					DecorSetInt(Ped,"mrppedfriend",1)
				--	BeginTextCommandSetBlipName("STRING")
				--	AddTextComponentString("Friend ($-"..getHostageKillPenalty(input)..")")
				--	EndTextCommandSetBlipName(pedb)				        
				elseif MissionType=="Assassinate" then --if ped is a target in assassinate
					--SetBlipColour(ped, 66)
					--SetBlipSprite(pedb, 433)
				--	SetBlipColour(pedb, 27)
					DecorSetInt(Ped,"mrppedtarget",1)
					--BeginTextCommandSetBlipName("STRING")
				--	AddTextComponentString("Target ($"..getTargetKillReward(input)..")")
				--	EndTextCommandSetBlipName(pedb)						
				else
					--SetBlipColour(pedb, 1)
					--BeginTextCommandSetBlipName("STRING")
					--AddTextComponentString("Enemy ($"..getKillReward(input)..")")
					--EndTextCommandSetBlipName(pedb)							
				
				end	

				--if Config.Missions[input].Vehicles[i].armor then --if ped has armor
					AddArmourToPed(Ped, 100)
					SetPedArmour(Ped, 100)
				--end						
				
				SetAiWeaponDamageModifier(1.0) -- 1.0 == Normal Damage. 
				-- ^ Sets Custom NPC Damage. ^
			end

		end
		
	end



end




--Used only for a mission with IsRandom flag set to true
function SetRandomMissionAttributes(MissionName,rMissionType,locationInfo) 
	
	if rMissionType	 == "Objective" then 
		Config.Missions[MissionName].MissionTitle = getMissionConfigProperty(MissionName, "MissionTitleObj")
		Config.Missions[MissionName].StartMessage = getMissionConfigProperty(MissionName, "StartMessageObj")
		Config.Missions[MissionName].FinishMessage = getMissionConfigProperty(MissionName, "FinishMessageObj")
		Config.Missions[MissionName].MissionMessage = getMissionConfigProperty(MissionName, "MissionMessageObj")	
		
		--allow random location overrides
		if(locationInfo.MissionTitleObj) then 
			Config.Missions[MissionName].MissionTitle = locationInfo.MissionTitleObj
		end
		if(locationInfo.StartMessageObj) then 
			Config.Missions[MissionName].StartMessage = locationInfo.StartMessageObj
		end
		if(locationInfo.MissionMessageObj) then 
			Config.Missions[MissionName].MissionMessage = locationInfo.MissionMessageObj
		end	
		
							

	elseif rMissionType	 == "Assassinate" then  
		Config.Missions[MissionName].MissionTitle = getMissionConfigProperty(MissionName, "MissionTitleAss")
		Config.Missions[MissionName].StartMessage = getMissionConfigProperty(MissionName, "StartMessageAss")
		Config.Missions[MissionName].FinishMessage = getMissionConfigProperty(MissionName, "FinishMessageAss")
		Config.Missions[MissionName].MissionMessage = getMissionConfigProperty(MissionName, "MissionMessageAss")	
		
		--allow random location overrides
		if(locationInfo.MissionTitleAss) then 
			Config.Missions[MissionName].MissionTitle = locationInfo.MissionTitleAss
		end
		if(locationInfo.StartMessageAss) then 
			Config.Missions[MissionName].StartMessage = locationInfo.StartMessageAss
		end
		if(locationInfo.MissionMessageAss) then 
			Config.Missions[MissionName].MissionMessage = locationInfo.MissionMessageAss
		end	
		
	end	
	
	--allow random location overrides
	if(locationInfo.MissionTitle) then 
			Config.Missions[MissionName].MissionTitle = locationInfo.MissionTitle
	end
	if(locationInfo.StartMessage) then 
			Config.Missions[MissionName].StartMessage = locationInfo.StartMessage
	end
	if(locationInfo.MissionMessage) then 
			Config.Missions[MissionName].MissionMessage = locationInfo.MissionMessage
	end	
	



end

--for IsRandom Missions places 1 prop at the Marker position for Objective Missions
--if HostageRescue and Type = "Assassinate" then spawn at least one hostage as a prop
function SpawnRandomProp(input,rIndex) 
		
		local randomLocation = getMissionConfigProperty(input, "RandomMissionPositions")[rIndex]
		local rHeading = roundToNthDecimal(math.random() + math.random(0,359),2)
		
		if Config.Missions[input].Type =="Objective" and not getMissionConfigProperty(input, "HostageRescue") then 
			local randomPropModelHash = getMissionConfigProperty(input, "RandomMissionProps")[math.random(1, #getMissionConfigProperty(input, "RandomMissionProps"))]		
			
			RequestModel(randomPropModelHash)
			while not HasModelLoaded(randomPropModelHash) do
				Wait(1)
			end
			Config.Missions[input].Props[1].Position.x = randomLocation.x
			Config.Missions[input].Props[1].Position.y = randomLocation.y
			Config.Missions[input].Props[1].Position.z = randomLocation.z
			if Config.Missions[input].Props[1].id and randomPropModelHash then 
				--local _, worldZ = GetGroundZFor_3dCoord(Config.Missions[input].Props[1].Position.x, Config.Missions[input].Props[1].Position.y, Config.Missions[input].Props[1].Position.z)
				--Config.Missions[input].Props[1].id = CreateObject(Config.Missions[input].Props[1].Name, Config.Missions[input].Props[1].Position.x, Config.Missions[input].Props[1].Position.y, worldZ, true, true, true)
				
				if randomLocation.Marker then 
				--place object in marker if it is defined for the mission
					Config.Missions[input].Peds[1].id = CreateObject(2, randomPropModelHash,  randomLocation.Marker.Position.x, randomLocation.Marker.Position.y, randomLocation.Marker.Position.z-1, true, false, true)
				else 
					Config.Missions[input].Props[1].id = CreateObject(randomPropModelHash, randomLocation.x, randomLocation.y, randomLocation.z - 1, true, false, true)
				end
				--print("PROP SPAWNED: ID:"..Config.Missions[input].Props[1].id)
				SetEntityHeading(Config.Missions[input].Props[1].id,rHeading)
				--print("PROP SPAWNED: DISTANCE FROM PLAYER:"..#(vector3(randomLocation.x, randomLocation.y, randomLocation.z) - vector3(coords.x,coords.y,coords.z)))
			
				DecorSetInt(Config.Missions[input].Props[1].id,"mrppropid",1)
				
				--if DoesEntityExist(Config.Missions[input].Props[1].id) then	
					--print("prop exists")
				--end
				--PlaceObjectOnGroundProperly(Config.Missions[input].Props[1].id) -- This function doesn't seem to work.
						--SetEntityAsMissionEntity(Config.Missions[input].Props[i].id, true, true)
			end
		elseif getMissionConfigProperty(input, "HostageRescue")  then
			local randomPropModelHash = getMissionConfigProperty(input, "RandomMissionFriendlies")[math.random(1, #getMissionConfigProperty(input, "RandomMissionFriendlies"))]		
			
			RequestModel(randomPropModelHash)
			while not HasModelLoaded(randomPropModelHash) do
				Wait(1)
			end
			
			Config.Missions[input].Peds[1].Position.x = randomLocation.x
			Config.Missions[input].Peds[1].Position.y = randomLocation.y
			Config.Missions[input].Peds[1].Position.z = randomLocation.z
			
			if Config.Missions[input].Peds[1].id and randomPropModelHash then 
				--local _, worldZ = GetGroundZFor_3dCoord(Config.Missions[input].Props[1].Position.x, Config.Missions[input].Props[1].Position.y, Config.Missions[input].Props[1].Position.z)
				--Config.Missions[input].Props[1].id = CreateObject(Config.Missions[input].Props[1].Name, Config.Missions[input].Props[1].Position.x, Config.Missions[input].Props[1].Position.y, worldZ, true, true, true)
				if randomLocation.Marker  then 
					--place hostage in marker if it is defined for the mission
					Config.Missions[input].Peds[1].id = CreatePed(2, randomPropModelHash,  randomLocation.Marker.Position.x, randomLocation.Marker.Position.y, randomLocation.Marker.Position.z-1, rHeading, true, true)
				else
					Config.Missions[input].Peds[1].id = CreatePed(2, randomPropModelHash, randomLocation.x, randomLocation.y, randomLocation.z-1, rHeading, true, true)
				end
				
				SetEntityAsMissionEntity(Config.Missions[input].Peds[1].id,true,true)
				
				
				--print("PROP SPAWNED: ID:"..Config.Missions[input].Props[1].id)
				SetEntityHeading(Config.Missions[input].Peds[1].id,rHeading)
				--print("PROP SPAWNED: DISTANCE FROM PLAYER:"..#(vector3(randomLocation.x, randomLocation.y, randomLocation.z) - vector3(coords.x,coords.y,coords.z))
				--print("spawned hostage rescue ped")
				DecorSetInt(Config.Missions[input].Peds[1].id,"mrppedfriend",1)
				DecorSetInt(Config.Missions[input].Peds[1].id,"mrppedid",1)
				SetPedRelationshipGroupHash(Config.Missions[input].Peds[1].id, GetHashKey("HOSTAGES"))
				SetRelationshipBetweenGroups(1, GetHashKey("HOSTAGES"), GetHashKey("HATES_PLAYER"))
				SetRelationshipBetweenGroups(1, GetHashKey("HOSTAGES"), GetHashKey("PLAYER"))
				
				TaskCower(Config.Missions[input].Peds[1].id,360000)
				
				--local pedb = AddBlipForEntity(Config.Missions[input].Peds[1].id)
				--local Size     = 0.9
				--SetBlipScale  (pedb, Size)
				--SetBlipAsShortRange(pedb, false)				
				
				--SetBlipColour(pedb, 2)
				--BeginTextCommandSetBlipName("STRING")
				--AddTextComponentString("Friend ($-"..getHostageKillPenalty(input)..")")
				--EndTextCommandSetBlipName(pedb)									
				
				
				--if DoesEntityExist(Config.Missions[input].Peds[1].id) then	
					--print("prop exists")
				--end
				--PlaceObjectOnGroundProperly(Config.Missions[input].Props[1].id) -- This function doesn't seem to work.
						--SetEntityAsMissionEntity(Config.Missions[input].Props[i].id, true, true)
			end
		
			
		
		
		end 
			

end

--[[
function SpawnRandomPropsTest(input,rIndex) 
		
		local randomLocation = getMissionConfigProperty(input, "RandomMissionPositions")[rIndex]
		local rHeading = roundToNthDecimal(math.random() + math.random(0,359),2)
		
		local dif = 0
		for i, v in pairs(getMissionConfigProperty(input, "RandomMissionProps")) do
			print("spawning prop"..v)
			local randomPropModelHash = v	
			RequestModel(randomPropModelHash)
			while not HasModelLoaded(randomPropModelHash) do
				Wait(1)
			end			
			
			Config.Missions[input].Props[1].Position.x = randomLocation.x
			Config.Missions[input].Props[1].Position.y = randomLocation.y
			Config.Missions[input].Props[1].Position.z = randomLocation.z
				if Config.Missions[input].Props[1].id and randomPropModelHash then 
					print("spawned prop"..v)
					--local _, worldZ = GetGroundZFor_3dCoord(Config.Missions[input].Props[1].Position.x, Config.Missions[input].Props[1].Position.y, Config.Missions[input].Props[1].Position.z)
					--Config.Missions[input].Props[1].id = CreateObject(Config.Missions[input].Props[1].Name, Config.Missions[input].Props[1].Position.x, Config.Missions[input].Props[1].Position.y, worldZ, true, true, true)
					Config.Missions[input].Props[1].id = CreateObject(randomPropModelHash, randomLocation.x + dif, randomLocation.y, randomLocation.z -1.0, true, true, true)
					
					SetEntityHeading(Config.Missions[input].Props[1].id,rHeading)
				
					DecorSetInt(Config.Missions[input].Props[1].id,"mrppropid",1)
					PlaceObjectOnGroundProperly(Config.Missions[input].Props[1].id) -- This function doesn't seem to work.
						--SetEntityAsMissionEntity(Config.Missions[input].Props[i].id, true, true)
				end	
			 dif = dif + 5		
			
		end	
		
	

end
]]--

function SpawnProps(input) 
				
			if(Config.Missions[input].Props) then 
				 for i=1, #Config.Missions[input].Props do     
					RequestModel(Config.Missions[input].Props[i].Name)
					while not HasModelLoaded(Config.Missions[input].Props[i].Name) do
						Wait(1)
					end
					--local _, worldZ = GetGroundZFor_3dCoord(Config.Missions[input].Props[i].Position.x, Config.Missions[input].Props[i].Position.y, Config.Missions[input].Props[i].Position.z)
					--Config.Missions[input].Props[i].id = CreateObject(Config.Missions[input].Props[i].Name, Config.Missions[input].Props[i].Position.x, Config.Missions[input].Props[i].Position.y, worldZ, true, true, true)
					Config.Missions[input].Props[i].id = CreateObject(Config.Missions[input].Props[i].Name, Config.Missions[input].Props[i].Position.x, Config.Missions[input].Props[i].Position.y, Config.Missions[input].Props[i].Position.z -1.0, true, true, true)
					if not Config.Missions[input].Props[i].dontsetheading then 
						
						SetEntityHeading(Config.Missions[input].Props[i].id,Config.Missions[input].Props[i].Position.heading)
					end 
					DecorSetInt(Config.Missions[input].Props[i].id,"mrppropid",i)
					--PlaceObjectOnGroundProperly(Config.Missions[input].Props[i].id) -- This function doesn't seem to work.
					--SetEntityAsMissionEntity(Config.Missions[input].Props[i].id, true, true)
				
				
				end
			end

end


function CleanupProps(input) 
	
	
	for obj in EnumerateObjects() do
		if(DecorGetInt(obj,"mrppropid")) > 0 then 
			
			DeleteObject(obj)
		
		end
	end

			
		--[[
			if(Config.Missions[input].Props) then 			
				 for i=1, #Config.Missions[input].Props do  
					if Config.Missions[input].Props[i].id and DoesEntityExist(Config.Missions[input].Props[i].id) then
							DeleteObject(Config.Missions[input].Props[i].id)
					end
				end
			end 
		]]--
			

end


function SpawnMissionPickupsOnPlayer(oldmission)

	if Config.Missions[oldmission].SpawnMissionPickupsOnPlayer ~=nil then

		return Config.Missions[oldmission].SpawnMissionPickupsOnPlayer
	else
		return Config.SpawnMissionPickupsOnPlayer
	end 


end

function SpawnMissionComponentsOnPlayer(oldmission)

	if Config.Missions[oldmission].SpawnMissionComponentsOnPlayer ~=nil then

		return Config.Missions[oldmission].SpawnMissionComponentsOnPlayer
	else
		return Config.SpawnMissionComponentsOnPlayer
	end 


end

function SpawnRewardPickupsOnPlayer(oldmission)

	if Config.Missions[oldmission].SpawnRewardPickupsOnPlayer ~=nil then

		return Config.Missions[oldmission].SpawnRewardPickupsOnPlayer
	else
		return Config.SpawnRewardPickupsOnPlayer
	end  


end

function SpawnRewardComponentsOnPlayer(oldmission)

	if Config.Missions[oldmission].SpawnRewardComponentsOnPlayer ~=nil then

		return Config.Missions[oldmission].SpawnRewardComponentsOnPlayer
	else
		return Config.SpawnRewardComponentsOnPlayer
	end 


end

function getSpawnMissionPickups(oldmission)

	local weaponlist = {}
	if Config.Missions[oldmission].SpawnMissionPickups ~=nil then
		weaponlist = Config.Missions[oldmission].SpawnMissionPickups

	else
		weaponlist = Config.SpawnMissionPickups
		
	end 
	giveWeaponsToPlayer(weaponlist) 
end

function getSpawnMissionComponents(oldmission)

	local weaponlist = {}
	if Config.Missions[oldmission].SpawnMissionComponents ~=nil then
		weaponlist = Config.Missions[oldmission].SpawnMissionComponents

	else
		weaponlist = Config.SpawnMissionComponents
		
	end 
	giveComponentsToPlayer(weaponlist) 
end




function getSpawnRewardPickups(oldmission)
	local weaponlist = {}
	if Config.Missions[oldmission].SpawnRewardPickups ~=nil then

		weaponlist = Config.Missions[oldmission].SpawnRewardPickups
	
	else
		weaponlist = Config.SpawnRewardPickups
	
	end 

	giveWeaponsToPlayer(weaponlist) 
end

function getSpawnRewardComponents(oldmission)
	local weaponlist = {}
	if Config.Missions[oldmission].SpawnRewardComponents ~=nil then

		weaponlist = Config.Missions[oldmission].SpawnRewardComponents
	
	else
		weaponlist = Config.SpawnRewardComponents
	
	end 

	giveComponentsToPlayer(weaponlist) 
end


function giveWeaponsToPlayer(weaponlist) 
	for i, v in pairs(weaponlist) do
		GiveWeaponToPed(GetPlayerPed(-1), GetHashKey(v), 1000, false)
	end

end

function giveComponentsToPlayer(weaponlist) 
	for i, v in pairs(weaponlist) do
		local component
		local weapon
		for token in string.gmatch(v, "[^%s]+") do
			if(component) then
				weapon=token
			else 
				component=token
			end
		end
		if HasPedGotWeapon(PlayerPedId(), GetHashKey(weapon), false) then
			GiveWeaponComponentToPed(GetPlayerPed(-1), GetHashKey(weapon), GetHashKey(component))
			
		end
	end

end



--Use RANDOM anymore?
function SpawnMissionPickups(oldmission) 
	local choosenWeapon = spawnablePickups[math.random(1, #spawnablePickups)]
	local pickupamount = 1.0
	
	
			if(SpawnMissionPickupsOnPlayer(oldmission)) then 
				--local coords = GetEntityCoords(GetPlayerPed(-1))
				--Config.Missions[oldmission].MissionPickups[i].id = CreatePickupRotate(GetHashKey(choosenWeapon),  coords.x,  coords.y, coords.z, 0.0, 0.0, 0.0, 8, pickupamount, 24, 24, true, GetHashKey(choosenWeapon))	
				 getSpawnMissionPickups(oldmission)
			end
			
			if(SpawnMissionComponentsOnPlayer(oldmission)) then 
				--local coords = GetEntityCoords(GetPlayerPed(-1))
				--Config.Missions[oldmission].MissionPickups[i].id = CreatePickupRotate(GetHashKey(choosenWeapon),  coords.x,  coords.y, coords.z, 0.0, 0.0, 0.0, 8, pickupamount, 24, 24, true, GetHashKey(choosenWeapon))	
				 getSpawnMissionComponents(oldmission)
			end			

			
			
			if(Config.Missions[oldmission].MissionPickups) then 					
				
				 for i=1, #Config.Missions[oldmission].MissionPickups do  
					
					if(Config.Missions[oldmission].MissionPickups[i].Name ~="RANDOM") then 
						choosenWeapon = Config.Missions[oldmission].MissionPickups[i].Name 
					end
					
					if(Config.Missions[oldmission].MissionPickups[i].Amount) then 
						pickupamount = Config.Missions[oldmission].MissionPickups[i].Amount 
					end
					
					Config.Missions[oldmission].MissionPickups[i].id = CreatePickupRotate(GetHashKey(choosenWeapon),  Config.Missions[oldmission].MissionPickups[i].Position.x,  Config.Missions[oldmission].MissionPickups[i].Position.y, Config.Missions[oldmission].MissionPickups[i].Position.z, 0.0, 0.0, 0.0, 8, pickupamount, 24, 24, true, GetHashKey(choosenWeapon))

					SetEntityDynamic(Config.Missions[oldmission].MissionPickups[i].id, true)
					SetEntityRecordsCollisions(Config.Missions[oldmission].MissionPickups[i].id, true)
					SetEntityHasGravity(Config.Missions[oldmission].MissionPickups[i].id, true)
					FreezeEntityPosition(Config.Missions[oldmission].MissionPickups[i].id, false)
					SetEntityVelocity(Config.Missions[oldmission].MissionPickups[i].id, 0.0, 0.0, -0.2)
					--DecorSetInt(Config.Missions[input].MissionPickups[i].id,"mrpmpickupid",i)
					
				end
			end			
					

end

--Use RANDOM anymore?
local pedpickups = {}
local pedvpickups = {}
function SpawnPickups(oldmission,rewardPlayer) 
	local choosenWeapon = spawnablePickups[math.random(1, #spawnablePickups)]
	local pickupamount = 1.0
	
		if rewardPlayer then 
			if(SpawnRewardPickupsOnPlayer(oldmission)) then 
				getSpawnRewardPickups(oldmission)
			end

			if(SpawnRewardComponentsOnPlayer(oldmission)) then 
				getSpawnRewardComponents(oldmission)
			end 
		end
				
			if(Config.Missions[oldmission].Pickups) then 					
				
				 for i=1, #Config.Missions[oldmission].Pickups do  
					
					if(Config.Missions[oldmission].Pickups[i].Name ~="RANDOM") then 
						choosenWeapon = Config.Missions[oldmission].Pickups[i].Name 
					end
					
					if(Config.Missions[oldmission].Pickups[i].Amount) then 
						pickupamount = Config.Missions[oldmission].Pickups[i].Amount 
					end
					
					Config.Missions[oldmission].Pickups[i].id = CreatePickupRotate(GetHashKey(choosenWeapon),  Config.Missions[oldmission].Pickups[i].Position.x,  Config.Missions[oldmission].Pickups[i].Position.y, Config.Missions[oldmission].Pickups[i].Position.z, 0.0, 0.0, 0.0, 8, pickupamount, 24, 24, true, GetHashKey(choosenWeapon))
					SetEntityDynamic(Config.Missions[oldmission].Pickups[i].id, true)
					SetEntityRecordsCollisions(Config.Missions[oldmission].Pickups[i].id, true)
					SetEntityHasGravity(Config.Missions[oldmission].Pickups[i].id, true)
					FreezeEntityPosition(Config.Missions[oldmission].Pickups[i].id, false)
					SetEntityVelocity(Config.Missions[oldmission].Pickups[i].id, 0.0, 0.0, -0.2)
					--DecorSetInt(Config.Missions[input].Pickups[i].id,"mrppickupid",i)
					
					
				end
			end
			
		--Dead enemies give pickups if enabled
		--Maybe allow for friendly peds to give  pickups as well?
		local pedcnt = 1
		if getPedsCanSpawnPickups(oldmission) then 
			for ped in EnumeratePeds() do
				
				if DecorGetInt(ped, "mrppedid") > 0 and IsEntityDead(ped) and not (DecorGetInt(ped, "mrppedfriend") > 0) then 
					
					local choosenWeapon = spawnablePickups[math.random(1, #spawnablePickups)]
					local coords = GetEntityCoords(ped)
					chosenWeapon = GetBestPedWeapon(ped,0) --or GetSelectedPedWeapon(ped) --either does not seem to give the weapon they carry
					pedpickups[pedcnt] = CreatePickupRotate(GetHashKey(choosenWeapon), coords.x,  coords.y, coords.z, 0.0, 0.0, 0.0, 8, pickupamount, 24, 24, true, GetHashKey(choosenWeapon))
				end

				if  DecorGetInt(ped, "mrpvpedid") > 0 and IsEntityDead(ped) and not (DecorGetInt(ped, "mrppedfriend") > 0) then
					local coords = GetEntityCoords(ped)
					local choosenWeapon = spawnablePickups[math.random(1, #spawnablePickups)]
					chosenWeapon = GetBestPedWeapon(ped,0) --GetSelectedPedWeapon(ped) --either does not seem to give the weapon they carry
					pedvpickups[pedcnt] = CreatePickupRotate(GetHashKey(choosenWeapon), coords.x,  coords.y, coords.z, 0.0, 0.0, 0.0, 8, pickupamount, 24, 24, true, GetHashKey(choosenWeapon))			
					
				end
				pedcnt = pedcnt + 1
				
			end		
		end
		
			
			

end

function getPedsCanSpawnPickups(oldmission) 

	
if Config.Missions[oldmission].EnemiesCanSpawnPickups ~= nil then
		return Config.Missions[oldmission].EnemiesCanSpawnPickups
	else
		return Config.EnemiesCanSpawnPickups
	end


end

function RemoveMissionPickup(x,y,z)
		
		for pickup in EnumeratePickups() do
			local coords = GetEntityCoords(pickup)

			if DoesEntityExist(pickup) and GetDistanceBetweenCoords(coords.x,coords.y,coords.z, x, y, z, true) < 1 then
			   --ugh, will not delete no matter what I try, so teleport off map for now
				--for ped drop pickups
				SetEntityCoords(pickup, -10000.647, -10000.97, 0.7186, 0.968)
				RemovePickup(pickup)
			end		

		end	
end


--decor does not work for pickups
function CleanupPickups(oldmission,ishost) 

--GET RID OF ishost
		
	if ishost then
		if(Config.Missions[oldmission].Pickups and Config.CleanupPickups) then 				
			 for i=1, #Config.Missions[oldmission].Pickups do     
						
				if Config.Missions[oldmission].Pickups[i].id and (DoesPickupExist(Config.Missions[oldmission].Pickups[i].id)) then
					
						SetEntityAsNoLongerNeeded(Config.Missions[oldmission].Pickups[i].id)
						RemovePickup(Config.Missions[oldmission].Pickups[i].id)
						DeleteObject(Config.Missions[oldmission].Pickups[i].id)				
						
									
				end								
			end
			
			 for i=1, #Config.Missions[oldmission].MissionPickups do     
				if Config.Missions[oldmission].MissionPickups[i].id and (DoesPickupExist(Config.Missions[oldmission].MissionPickups[i].id)) then
					
						SetEntityAsNoLongerNeeded(Config.Missions[oldmission].MissionPickups[i].id)
						RemovePickup(Config.Missions[oldmission].MissionPickups[i].id)
						DeleteObject(Config.Missions[oldmission].MissionPickups[i].id)				
										
					
								
				end				
				
			end					
		end

	end
	--[[
		if(Config.CleanupPickups and Config.Missions[oldmission].Pickups) then 				
			 for i=1, #Config.Missions[oldmission].Pickups do     
				
					RemoveMissionPickup(Config.Missions[oldmission].Pickups[i].Position.x,Config.Missions[oldmission].Pickups[i].Position.y,Config.Missions[oldmission].Pickups[i].Position.z)
							
			end
			
		end	
		
		if(Config.CleanupPickups and Config.Missions[oldmission].MissionPickups) then 	
			
				 for i=1, #Config.Missions[oldmission].MissionPickups do     
					
						RemoveMissionPickup(Config.Missions[oldmission].MissionPickups[i].Position.x,Config.Missions[oldmission].MissionPickups[i].Position.y,Config.Missions[oldmission].MissionPickups[i].Position.z)		
					
				end
		end
]]--
		--ped drop pickup removal
			if(pedpickups) then 
			--remove ped dropped pickups too	
				for i, v in pairs(pedpickups) do
					SetEntityAsNoLongerNeeded(v)
					RemovePickup(v)
					DeleteObject(v)							
				end
			end
			
			if(pedvpickups) then 
			--remove ped dropped pickups too	
				for i, v in pairs(pedvpickups) do
					SetEntityAsNoLongerNeeded(v)
					RemovePickup(v)
					DeleteObject(v)								
					
				end
			end			
			
			pedpickups = {}
			pedvpickups = {}		

		
end




function ExitOldMissionAndStartNewMission(oldmission,isfail,reasontext)
	--choose random mission that is not the old one. 
	--***Config.Missions keys in mission.lua need to be Mission1, Mission2, ....MissionN, MissionN+1***

	--#Config.Missions gives 0, so lets do this: 
	local missioncount = 0;
	for i, v in pairs(Config.Missions) do
		missioncount = missioncount + 1
	end

	local nextmission = ""

	if Config.RandomMissions then
		nextmission = "Mission"..tostring(math.random(1,missioncount))
	else 
		local oldMissionNumber, _ = oldmission:gsub("%D+", "")
		if (tonumber(oldMissionNumber) + 1 > missioncount) then 
			nextmission = "Mission1"
		 else
			nextmission =  "Mission" .. tostring(math.floor((tonumber(oldMissionNumber))) + 1)
		
		end
	end 
	

	if missioncount > 1 then 
		while( nextmission == oldmission )
		do
		   nextmission = "Mission"..tostring( math.random(1,missioncount))
		end
	else 
		nextmission = oldmission 
	end
	
	--finish off old mission
    Active = 0
	TriggerServerEvent("sv:done", MissionName,false,isfail,reasontext)
   -- TriggerEvent("DONE", MissionName)
    --aliveCheck()
	
	--SpawnPickups(oldmission) 
	--MissionName = "N/A" --GHK DOESNT NEED TO BE CALLED
	

	--do this on the server.
	TriggerServerEvent("sv:checkhostandremovepickups",oldmission, nextmission, Config.MissionSpaceTime)
	--wait for old mission to wrap up. Host player could disconnect here, before new mission starts, whereby another player will need to use /mission , 
	--'sv:checkhostandremovepickups' tries to alert other players of this, if so and start another mission, if the server flag is set
	Citizen.Wait(getMissionSpaceTime(oldmission)) 
	--'host' (mission starter) player can reliably delete the pickups as well, 'sv:checkhostandremovepickups' and might be a better solution to the code between  ----------
	CleanupPickups(oldmission,true)

	local rMissionLocationIndex = 0
	local rMissionType = Config.RandomMissionTypes[math.random(1, #Config.RandomMissionTypes)]
			for i, v in pairs(Config.Missions) do
				if nextmission == i then
					if Active == 1 then
						TriggerEvent('chatMessage', "^1[MISSIONS]: ^2Next Mission...There is a mission already in progress.")
					else
					Active = 1
					MissionName = nextmission
					--MissionName = MissionName
					time = 10000
					--TriggerServerEvent("sv:one", nextmission, Config.Missions[nextmission].MissionTitle, time,rMissionLocationIndex)
					
					if(Config.Missions[nextmission].IsRandom) then 
						
						rMissionLocationIndex = math.random(1, #getMissionConfigProperty(nextmission, "RandomMissionPositions"))
						
						if(getMissionConfigProperty(nextmission, "RandomMissionPositions")[rMissionLocationIndex].force) then
							
							rMissionType = "Objective" --NPCs have a chance of spawning in buildings with forced = true, so Assassinate may hang
						end					
						

						SetRandomMissionAttributes(nextmission,rMissionType, getMissionConfigProperty(nextmission, "RandomMissionPositions")[rMissionLocationIndex]) 
							
						--local chosenLocation = Config.RandomMissionPositions[math.random(1, rIndex)]					
					end 
					
					TriggerServerEvent("sv:one",nextmission, Config.Missions[nextmission].MissionTitle, time,rMissionLocationIndex,rMissionType)
					
					if(Config.Missions[nextmission].IsRandom) then 
						TriggerEvent("SpawnRandomPed", nextmission,rMissionType, math.random(getMissionConfigProperty(MissionName, "RandomMissionMinPedSpawns"), getMissionConfigProperty(MissionName, "RandomMissionMaxPedSpawns")), math.random(getMissionConfigProperty(MissionName, "RandomMissionMinVehicleSpawns"),getMissionConfigProperty(MissionName, "RandomMissionMaxVehicleSpawns")),rMissionLocationIndex)
					else
						TriggerEvent("SpawnPed", nextmission)
					end					
					
					--Wait 5 seconds for peds to spawn on client/host and migrate to other clients.
					--before spawning NPC blips etc..
					--Wait(5000)
					--TriggerServerEvent("sv:one",nextmission, Config.Missions[nextmission].MissionTitle, time,rMissionLocationIndex,rMissionType)
					
					
					
					--TriggerEvent("SpawnPed", nextmission)
					end
				end
			end
			--SpawnProps(oldmission)
end

--get the time in milliseconds for reward pickups to be around (if CleanPickups = true) and until next mission is started
function getMissionSpaceTime(oldmission) 

	if Config.Missions[oldmission].MissionSpaceTime ~=nil then

		return Config.Missions[oldmission].MissionSpaceTime
	else
		return Config.MissionSpaceTime
	end


end

function aliveCheck()
    MissionName = MissionName
   
   while Active == 1 do
   
		for ped in EnumeratePeds() do

			if (DecorGetInt(ped, "mrppedid") > 0 or DecorGetInt(ped, "mrpvpedid") > 0) and IsEntityDead(ped) then
				local blip = GetBlipFromEntity(ped)
				RemoveBlip(blip)
			end
				
		end
			
			
      
	--[[
	  for i=1, #Config.Missions[MissionName].Peds do
            if IsEntityDead(Config.Missions[MissionName].Peds[i].id) then
                local ped  = Config.Missions[MissionName].Peds[i].id
                local blip = GetBlipFromEntity(ped)
                RemoveBlip(blip)
            end
        end
        for i=1, #Config.Missions[MissionName].Vehicles do
            if IsEntityDead(Config.Missions[MissionName].Vehicles[i].id2) then --change to id2, the ped
                local veh  = Config.Missions[MissionName].Vehicles[i].id2
                local blip = GetBlipFromEntity(veh)
                RemoveBlip(blip)
            end
        end
		]]--
		
        Citizen.Wait(2500)
    end
end

function calcMissionStats() 
	local totalTargets = 0
	local totalDeadTargets = 0
	local targetPedsKilledByPlayer = 0
	local nontargetPedsKilledByPlayer = 0
	local hostagesKilledByPlayer = 0
	local totalDeadHostages = 0
	
	
	
	
	--[[
	if not Config.Missions[MissionName].IsRandom then 
	
		totalTargets = Config.Missions[MissionName].PedRandomCount + Config.Missions[MissionName].PedVehicleRandomCount --Peds + Peds with vehicles
		
		
		
	
	else 
	    --
	    for i=1, #Config.Missions[MissionName].Peds do
		
            if Config.Missions[MissionName].Peds[i].target then
				totalTargets = totalTargets + 1
			end
			
        end
		
        for i=1, #Config.Missions[MissionName].Vehicles do
		
            if Config.Missions[MissionName].Vehicles[i].target then
				totalTargets = totalTargets + 1
			end
		
        end			
	end 
	]]-- 
		--**may need to do getBlip to see if we need to add a blip for any stragglers from previous missions***
		for ped in EnumeratePeds() do

			if (DecorGetInt(ped, "mrppedid") > 0 or DecorGetInt(ped, "mrpvpedid") > 0)  then
			
				if (DecorGetInt(ped, "mrppedtarget") > 0) then	
					totalTargets = totalTargets + 1
				end
			
			
				if IsEntityDead(ped) then
					if (DecorGetInt(ped, "mrppedtarget") > 0) then	
						totalDeadTargets = totalDeadTargets + 1

						if(GetPedKiller(ped)==GetPlayerPed(-1)) then
							targetPedsKilledByPlayer = targetPedsKilledByPlayer + 1
						end	

					elseif(DecorGetInt(ped, "mrppedfriend") > 0) then
							totalDeadHostages = totalDeadHostages + 1
						if(GetPedKiller(ped)==GetPlayerPed(-1)) then
							hostagesKilledByPlayer = hostagesKilledByPlayer +1
						end					
			
					elseif IsEntityDead(ped) then 
					
						if(GetPedKiller(ped)==GetPlayerPed(-1)) then
							nontargetPedsKilledByPlayer = nontargetPedsKilledByPlayer + 1
						end						
					
					
					end
				end	
				
					
			
			end
				
		end	
	
	--[[
       for i=1, #Config.Missions[MissionName].Peds do
		
            if Config.Missions[MissionName].Peds[i].target then
				totalTargets = totalTargets + 1
				if IsEntityDead(Config.Missions[MissionName].Peds[i].id) then
					totalDeadTargets = totalDeadTargets + 1
					if(GetPedKiller(Config.Missions[MissionName].Peds[i].id)==GetPlayerPed(-1)) then
						targetPedsKilledByPlayer = targetPedsKilledByPlayer + 1
					end
				end	
			else --nontargets
				if IsEntityDead(Config.Missions[MissionName].Peds[i].id) then
					if(GetPedKiller(Config.Missions[MissionName].Peds[i].id)==GetPlayerPed(-1)) then
						nontargetPedsKilledByPlayer = nontargetPedsKilledByPlayer + 1
					end
				end				
			
            end	
			
        end
        for i=1, #Config.Missions[MissionName].Vehicles do
		
            if Config.Missions[MissionName].Vehicles[i].target then
				totalTargets = totalTargets + 1
				if IsEntityDead(Config.Missions[MissionName].Vehicles[i].id2) then
					totalDeadTargets = totalDeadTargets + 1
					if(GetPedKiller(Config.Missions[MissionName].Vehicles[i].id2)==GetPlayerPed(-1)) then
						targetPedsKilledByPlayer = targetPedsKilledByPlayer + 1
						
					end					
				end	
			else --nontargets
				if IsEntityDead(Config.Missions[MissionName].Vehicles[i].id2) then
					if(GetPedKiller(Config.Missions[MissionName].Vehicles[i].id2)==GetPlayerPed(-1)) then
						nontargetPedsKilledByPlayer = nontargetPedsKilledByPlayer + 1
					end					
				end				
			
			
            end			
		
        end	
		
		]]--
	return {nontargetPedsKilledByPlayer,targetPedsKilledByPlayer,hostagesKilledByPlayer,totalTargets,totalDeadTargets,totalDeadHostages}

end


function calcHostageKillPenalty(hostagePedsKilledByPlayer,totalDeadHostages)
		
		local targetmoney = 0
		local regularmoney = 0
		local objectivemoney = 0
		local penaltymoney = 0
		local totalmoney = 0
		--local currentmoney = 0
		--StatSetInt('MP0_WALLET_BALANCE', 0, true)
		--StatSetInt('BANK_BALANCE', 0, true)
		
		if Config.Missions[MissionName].HostageKillPenalty then
			 penaltymoney = Config.Missions[MissionName].HostageKillPenalty*hostagePedsKilledByPlayer
			 --penaltymoney = Config.Missions[MissionName].HostageKillPenalty*totalDeadHostages
		else 
			penaltymoney = Config.HostageKillPenalty*hostagePedsKilledByPlayer
			--penaltymoney = Config.HostageKillPenalty*totalDeadHostages
		end	
		
		--playerSecured = false
		local _,currentmoney = StatGetInt('MP0_WALLET_BALANCE',-1)
		playerMissionMoney =  0 - penaltymoney
		totalmoney =  currentmoney - penaltymoney
		--print('HOSTAGE KILLED PENALTY:'..playerMissionMoney)
		--ESX Support, else use Native Money
		if UseESX then 
			TriggerServerEvent("paytheplayer", totalmoney)
			TriggerServerEvent("UpdateUserMoney", totalmoney)
		else
			StatSetInt('MP0_WALLET_BALANCE',totalmoney, true)
		end 
		


end

function calcCompletionRewards(nonTargetPedsKilledByPlayer,targetPedsKilledByPlayer,hostagePedsKilledByPlayer,totalDeadHostages)
		
		local targetmoney = 0
		local regularmoney = 0
		local objectivemoney = 0
		local penaltymoney = 0
		local totalmoney = 0
		local hostagerecuemoney = 0
		--local currentmoney = 0
		--StatSetInt('MP0_WALLET_BALANCE', 0, true)
		--StatSetInt('BANK_BALANCE', 0, true)
		
		if Config.Missions[MissionName].TargetKillReward  then
			 targetmoney = Config.Missions[MissionName].TargetKillReward*targetPedsKilledByPlayer
		else 
			targetmoney = Config.TargetKillReward*targetPedsKilledByPlayer
		end
		
		if Config.Missions[MissionName].KillReward  then
			 regularmoney = Config.Missions[MissionName].KillReward*nonTargetPedsKilledByPlayer
		else 
			regularmoney = Config.KillReward*nonTargetPedsKilledByPlayer
		end

		if Config.Missions[MissionName].HostageKillPenalty then
			 penaltymoney = Config.Missions[MissionName].HostageKillPenalty*hostagePedsKilledByPlayer
			 --penaltymoney = Config.Missions[MissionName].HostageKillPenalty*totalDeadHostages
		else 
			penaltymoney = Config.HostageKillPenalty*hostagePedsKilledByPlayer
			--penaltymoney = Config.HostageKillPenalty*totalDeadHostages
		end	
		
		if playerSecured then 
			
			if Config.Missions[MissionName].FinishedObjectiveReward  then
				objectivemoney = Config.Missions[MissionName].FinishedObjectiveReward
			else 
				objectivemoney = Config.FinishedObjectiveReward
			end		
		
		end 
		
		if DecorGetInt(GetPlayerPed(-1),"mrprescuecount") then 
		
			if DecorGetInt(GetPlayerPed(-1),"mrprescuecount") > 0 then 
				local hostagerescues = DecorGetInt(GetPlayerPed(-1),"mrprescuecount")
				if Config.Missions[MissionName].HostageRescueReward  then
					hostagerecuemoney =  Config.Missions[MissionName].HostageRescueReward*hostagerescues
				else 
					hostagerecuemoney =  Config.HostageRescueReward*hostagerescues
				end					
				--reset rescue count
				DecorSetInt(GetPlayerPed(-1),"mrprescuecount",0)
			
			end
		
		end
		
		--print('hostagerecuemoney'..hostagerecuemoney)
		--print('objectivemoney'..objectivemoney)
		--print('penaltymoney'..penaltymoney)
		--print('regularmoney'..regularmoney)
		--print('targetmoney'..targetmoney)

		
		--playerSecured = false
		local _,currentmoney = StatGetInt('MP0_WALLET_BALANCE',-1)
		playerMissionMoney = targetmoney + regularmoney + objectivemoney + hostagerecuemoney - penaltymoney
		totalmoney =  currentmoney + targetmoney + regularmoney + objectivemoney + hostagerecuemoney - penaltymoney
		
		--ESX Support, else use Native Money
		if UseESX then 
			TriggerServerEvent("paytheplayer", totalmoney)
			TriggerServerEvent("UpdateUserMoney", totalmoney)
		else
			StatSetInt('MP0_WALLET_BALANCE',totalmoney, true)
		end 
		


end

function getObjectiveReward(MissionName) 
	local retval = "N/A"
	if Config.Missions[MissionName].Type=="Objective" then 
		if Config.Missions[MissionName].FinishedObjectiveReward  then
			return Config.Missions[MissionName].FinishedObjectiveReward
		else 
			return Config.FinishedObjectiveReward
		end
	else
		return retval
	end
end

function getHostageKillPenalty(MissionName) 
			
	if Config.Missions[MissionName].HostageKillPenalty then
		return Config.Missions[MissionName].HostageKillPenalty	 
	else 
		return Config.HostageKillPenalty		
	end	

end


function getKillReward(MissionName) 
			
		if Config.Missions[MissionName].KillReward  then
			 return Config.Missions[MissionName].KillReward
		else 
			return Config.KillReward
		end
	

end

function getTargetKillReward(MissionName) 
			
		if Config.Missions[MissionName].TargetKillReward  then
			 return Config.Missions[MissionName].TargetKillReward
		else 
			return Config.TargetKillReward
		end
	

end

--Used in Assassinate which has IsDefend = true
--Checks to see if 
function hasBeenConquered(MissionName) 
	--loop through to see if the marker area has an enemy in it
	--print("hasBeenConquered CHECK")
	for ped in EnumeratePeds() do
		
		if (DecorGetInt(ped, "mrppedid") > 0 or DecorGetInt(ped, "mrpvpedid") > 0) and (not IsEntityDead(ped)) and (DecorGetInt(ped, "mrppedfriend") == 0) then 
			--print("2hasBeenConquered CHECK")
			local coords  --= vector3(0.0,0.0,0.0)
			if GetVehiclePedIsUsing(ped) ~= 0 then --GetVehiclePedIsIn(ped, false)
				--print("hasBeenConquered vped")
			
				coords =  GetEntityCoords(GetVehiclePedIsUsing(ped))
				--print("vehcoords:"..coords.x.."|"..coords.y.."|"..coords.z)
			else 
				--print("hasBeenConquered ped")
				coords =  GetEntityCoords(ped)
				--print("pedcoords:"..coords.x.."|"..coords.y.."|"..coords.z)
			end
			
			if(GetDistanceBetweenCoords(coords.x,coords.y,coords.z, Config.Missions[MissionName].Marker.Position.x, Config.Missions[MissionName].Marker.Position.y, Config.Missions[MissionName].Marker.Position.z, true) < Config.Missions[MissionName].Marker.Size.x / 2) then
				--print("coords:"..coords.x.."|"..coords.y.."|"..coords.z)
				--print("markercoords:"..Config.Missions[MissionName].Marker.Position.x.."|".. Config.Missions[MissionName].Marker.Position.y.."|".. Config.Missions[MissionName].Marker.Position.z)
				--print("distance:"..GetDistanceBetweenCoords(coords.x,coords.y,coords.z, Config.Missions[MissionName].Marker.Position.x, Config.Missions[MissionName].Marker.Position.y, Config.Missions[MissionName].Marker.Position.z, true))
				--print("hasBeenConquered true")
				return true 

			end
			
		end

	end	

		--print("hasBeenConquered falsse")
		return false


end

function rescuingHostage() 

	for ped in EnumeratePeds() do
		
		if (DecorGetInt(ped, "mrppedfriend") > 0 and not IsEntityDead(ped) )  then
		
				if IsEntityAtEntity(GetPlayerPed(-1), ped, 1.0, 1.0, 2.0, 0, 1, 0) then
					SetEntityInvincible(ped,true)
					ClearPedTasksImmediately(ped)
					DecorSetInt(ped,"mrppedfriend", 0)
					TaskSmartFleePed(ped, GetPlayerPed(-1), 10000.0, -1) 
					--DeleteEntity(ped)
					if not DecorGetInt(GetPlayerPed(-1),"mrprescuecount") then 
						DecorSetInt(GetPlayerPed(-1),"mrprescuecount", 1)
					else 
						DecorSetInt(GetPlayerPed(-1),"mrprescuecount",(DecorGetInt(GetPlayerPed(-1),"mrprescuecount") + 1))
					end
					
					return true
				end			
		
		end

	end	
	return false

end

function MissionCheck()
	local totalTargets = 0
	local totalDeadTargets = 0
	local targetPedsKilledByPlayer = 0
	local nontargetPedsKilledByPlayer = 0
	local hostagePedsKilledByPlayer = 0
	local results
	local isfail = false
  
	PLY = PlayerId()
	PLYN = GetPlayerName(PLY)
		--Wait called in loop now:
		--Citizen.Wait(1000)
		results = calcMissionStats()
		totalTargets = results[4]
		totalDeadTargets = results[5]
		totalDeadHostages = results[6]
		nontargetPedsKilledByPlayer = results[1]
		targetPedsKilledByPlayer = results[2]
		hostagePedsKilledByPlayer = results[3]
		

		if (Active == 1) and  MissionName ~="N/A" then 
			--print("MISSIONCHECK:"..MissionName)
			--print("MISSIONCHECK:"..tostring(getMissionConfigProperty(MissionName, "IsDefend")))
			if(totalTargets  == totalDeadTargets) and Config.Missions[MissionName].Type == "Assassinate" then --and PedsSpawned == 1 then --need at least 1 target, or the mission will autocomplete on start
				--print("MISSIONCHECK DONE1")
				securing = false --needed?
				
				
				--message  = "^1[MISSIONS]: ^2".. PLYN .."^0 has assassinated all the targets!"
	
				message2 = "^1[MISSIONS]: ^2'".. Config.Missions[MissionName].MissionTitle .."'^0 has been completed!"
				
			   -- TriggerServerEvent("sv:two", message)
				TriggerServerEvent("sv:two", message2)
				Active = 0
				--TriggerServerEvent("sv:done", MissionName)
				--TriggerEvent("DONE", MissionName)
				aliveCheck()
				local oldmission = MissionName
				--MissionName = "N/A"
				ExitOldMissionAndStartNewMission(oldmission,isfail,"") --GHK Start New Mission
			
			--IsDefend requires Assassinate Type?
			elseif getMissionConfigProperty(MissionName, "IsDefend") and hasBeenConquered(MissionName) then --and Config.Missions[MissionName].Type == "Assassinate" and hasBeenConquered(MissionName) then
				--print("MISSIONCHECK ISDEFEND")
				isfail = true
				PLY = PlayerId()
				PLYN = GetPlayerName(PLY)
				local reasontext = "Enemies have reached the objective"
				message = "^1[MISSIONS]: ^1 Enemies have reached the objective"
				message2 = "^1[MISSIONS]: ^2'".. Config.Missions[MissionName].MissionTitle .."'^0 mission has failed!"
			   -- TriggerServerEvent("sv:two", message)
				TriggerServerEvent("sv:two", message)
				TriggerServerEvent("sv:two", message2)
				Active = 0
				--TriggerServerEvent("sv:done", MissionName)
				--TriggerEvent("DONE", MissionName)
				aliveCheck()
				local oldmission = MissionName
				--MissionName = "N/A"
				ExitOldMissionAndStartNewMission(oldmission,isfail,reasontext) --GHK Start New Mission								
			
			
			
			elseif getMissionConfigProperty(MissionName, "HostageRescue") and hostagePedsKilledByPlayer > 0 then --and Config.Missions[MissionName].Type == "Assassinate" then
				--print("MISSIONCHECK DONE2")
				isfail = true
				PLY = PlayerId()
				PLYN = GetPlayerName(PLY)
				local reasontext = PLYN.." has killed a hostage"
				message = "^1[MISSIONS]: ^2 "..PLYN.."^1 has killed a hostage"
				message2 = "^1[MISSIONS]: ^2'".. Config.Missions[MissionName].MissionTitle .."'^0 mission has failed!"
			   -- TriggerServerEvent("sv:two", message)
				TriggerServerEvent("sv:two", message)
				TriggerServerEvent("sv:two", message2)
				Active = 0
				--TriggerServerEvent("sv:done", MissionName)
				--TriggerEvent("DONE", MissionName)
				aliveCheck()
				local oldmission = MissionName
				--MissionName = "N/A"
				ExitOldMissionAndStartNewMission(oldmission,isfail,reasontext) --GHK Start New Mission				
				
			elseif getMissionConfigProperty(MissionName, "HostageRescue") and totalDeadHostages > 0 then --and Config.Missions[MissionName].Type == "Assassinate" then
				--print("MISSIONCHECK DONE2")
				isfail = true
				PLY = PlayerId()
				PLYN = GetPlayerName(PLY)
				local reasontext = "A hostage has died"
				message = "^1[MISSIONS]: ^1 A hostage has died"
				message2 = "^1[MISSIONS]: ^2'".. Config.Missions[MissionName].MissionTitle .."'^0 mission has failed!"
			   -- TriggerServerEvent("sv:two", message)
				TriggerServerEvent("sv:two", message)
				TriggerServerEvent("sv:two", message2)
				Active = 0
				--TriggerServerEvent("sv:done", MissionName)
				--TriggerEvent("DONE", MissionName)
				aliveCheck()
				local oldmission = MissionName
				--MissionName = "N/A"
				ExitOldMissionAndStartNewMission(oldmission,isfail,reasontext) --GHK Start New Mission		
			
			
			elseif rescuingHostage() then --and Config.Missions[MissionName].Type == "Assassinate" then
				--isfail = true
				--print("rescued hostage")
				PLY = PlayerId()
				PLYN = GetPlayerName(PLY)
				--local reasontext = PLYN.." has rescued a hostage"
				message = ""..PLYN.." has rescued a hostage"
				message2 = "^1[MISSIONS]: ^2 "..PLYN.."^0 has rescued a hostage"
				TriggerServerEvent("sv:two", message2)
				TriggerServerEvent("sv:message", message)
				PlaySoundFrontend(-1, "ROUND_ENDING_STINGER_CUSTOM", "CELEBRATION_SOUNDSET", 1)
				--TriggerServerEvent("sv:two", message2)
				--Active = 0
				--TriggerServerEvent("sv:done", MissionName)
				--TriggerEvent("DONE", MissionName)
				--aliveCheck()
				--local oldmission = MissionName
				--MissionName = "N/A"
				--ExitOldMissionAndStartNewMission(oldmission,isfail,reasontext) --GHK Start New Mission	
						
				
			end
		end
   -- end

end

function SecureObj()
    local SecureTime = 5
    while securing == true do
		
        PLY = PlayerId()
        PLYN = GetPlayerName(PLY)
        if SecureTime > 0 then
            message  = "~u~(~g~Capture Progress: ~r~".. SecureTime .."~u~)"
            SecureTime = SecureTime - 1
            TriggerEvent("mt:missiontext2", message, 1000)
            Citizen.Wait(1000)
			PlaySoundFrontend(-1, "3_2_1", "HUD_MINI_GAME_SOUNDSET", 1)
        end
        if SecureTime == 0 then
            securing = false
			local reasontext = PLYN .." has captured the objective!"
            message  = "^1[MISSIONS]: ^2".. PLYN .."^0 has captured the objective!"
            message2 = "^1[MISSIONS]: ^2'".. Config.Missions[MissionName].MissionTitle .."'^0 has been completed!"
            TriggerServerEvent("sv:two", message)
            TriggerServerEvent("sv:two", message2)
			TriggerServerEvent("giveitem")
           -- Active = 0
			--TriggerServerEvent("sv:done", MissionName)
            ----TriggerEvent("DONE", MissionName)
            --aliveCheck()
			local oldmission = MissionName
			--MissionName = "N/A"
		    --Reward player
			local objectivemoney
			if Config.Missions[MissionName].FinishedObjectiveReward then
				objectivemoney = Config.Missions[MissionName].FinishedObjectiveReward
			else 
				objectivemoney = Config.FinishedObjectiveReward
			end

			playerSecured = true
			
			ExitOldMissionAndStartNewMission(oldmission,false,reasontext) --GHK Start New Mission
            --MissionName = "N/A"
        end
        
        if SecureTime == 5 then
            TriggerEvent("chatMessage", "You are now capturing the objective.")
            message  = "^1[MISSIONS]: ^2".. PLYN .."^0 is now capturing the objective."
            message2  = "^1[MISSIONS]: ^1(Capture Progress: ".. SecureTime .." )"
            TriggerServerEvent("sv:two", message)
            TriggerEvent("chatMessage", message2)
            SecureTime = SecureTime - 1
            Citizen.Wait(1000)
			PlaySoundFrontend(-1, "3_2_1", "HUD_MINI_GAME_SOUNDSET", 1)
        end
    end
end

Citizen.CreateThread(function()
    while true do
        Citizen.Wait(0)
        if MissionName ~= "N/A" then
		   if Config.Missions[MissionName].Type == "Objective" or (Config.Missions[MissionName].Type == "Assassinate" and Config.Missions[MissionName].Defend) then 
				for k,v in pairs(Config.Missions[MissionName].Marker) do
					local coords = GetEntityCoords(GetPlayerPed(-1))
					if(GetDistanceBetweenCoords(coords.x,coords.y,coords.z, Config.Missions[MissionName].Marker.Position.x, Config.Missions[MissionName].Marker.Position.y, Config.Missions[MissionName].Marker.Position.z, true) < Config.Missions[MissionName].Marker.DrawDistance) then
						DrawMarker(Config.Missions[MissionName].Marker.Type, Config.Missions[MissionName].Marker.Position.x, Config.Missions[MissionName].Marker.Position.y, Config.Missions[MissionName].Marker.Position.z, 0.0, 0.0, 0.0, 0, 0.0, 0.0, Config.Missions[MissionName].Marker.Size.x, Config.Missions[MissionName].Marker.Size.y, Config.Missions[MissionName].Marker.Size.z, Config.Missions[MissionName].Marker.Color.r, Config.Missions[MissionName].Marker.Color.g, Config.Missions[MissionName].Marker.Color.b, 100, false, true, 2, false, false, false, false)
					end
				end
			end
        end
    end
end)


Citizen.CreateThread(function()
    while true do
        Citizen.Wait(1000)
		if Active == 1 and MissionName ~="N/A" then
			if PedsSpawned == 1 then
				MissionCheck()
			end
		end
		--Update GUI if enabled.
		if showNativeMoneyGUI and not UseESX then 
		
			_,currentplayerNmoney = StatGetInt('MP0_WALLET_BALANCE',-1)
			
		end 

	
    end
end)




Citizen.CreateThread(function()
    while true do
        Citizen.Wait(0)
        if Active == 1 and MissionName ~="N/A" then
		
			if Config.Missions[MissionName].Type == "Objective" then 
				for k,v in pairs(Config.Missions[MissionName].Marker) do
					if Active == 1 and MissionName ~="N/A" then

						ply = PlayerId()
						coords = GetEntityCoords(GetPlayerPed(ply))
						if(GetDistanceBetweenCoords(coords.x,coords.y,coords.z, Config.Missions[MissionName].Marker.Position.x, Config.Missions[MissionName].Marker.Position.y, Config.Missions[MissionName].Marker.Position.z, true) < Config.Missions[MissionName].Marker.Size.x / 2) and not securing then
							if IsPedOnFoot(GetPlayerPed(ply)) then 
								securing = true
								SecureObj()
							else
								securing = false
							end
						end
					end
				end
			--elseif Config.Missions[MissionName].Type == "Assassinate" and PedsSpawned == 1 then --assassinate mission
				--MissionCheck()
			end
        end
    end
end) 

Citizen.CreateThread(function()
    while true do
        Citizen.Wait(0)

		if showNativeMoneyGUI and not UseESX then
		
			SetTextFont(0)
            SetTextProportional(1)
            SetTextScale(0.0, 0.3)
            SetTextColour(0, 128, 0, 255)
            SetTextDropshadow(0, 0, 0, 0, 255)
            SetTextEdge(1, 0, 0, 0, 255)
            SetTextDropShadow()
            SetTextOutline()
            SetTextEntry("STRING")
            AddTextComponentString("$"..currentplayerNmoney)
            DrawText(0.175, 0.955)		
		

		end		
		
        if Active == 1 and MissionName ~="N/A" then
			SetTextFont(0)
            SetTextProportional(1)
            SetTextScale(0.0, 0.4)
            SetTextColour(255, 255, 255, 255)
            SetTextDropshadow(0, 0, 0, 0, 255)
            SetTextEdge(1, 0, 0, 0, 255)
            SetTextDropShadow()
            SetTextOutline()
            SetTextEntry("STRING")
            AddTextComponentString("Évènement: ~r~"..Config.Missions[MissionName].MissionTitle)
            DrawText(0.625, 0.030)		
		
			SetTextFont(0)
            SetTextProportional(1)
            SetTextScale(0.0, 0.3)
            SetTextColour(99, 209, 62, 255)
            SetTextDropshadow(0, 0, 0, 0, 255)
            SetTextEdge(1, 0, 0, 0, 255)
            SetTextDropShadow()
            SetTextOutline()
            SetTextEntry("STRING")
            AddTextComponentString(Config.Missions[MissionName].MissionMessage)
            DrawText(0.625, 0.065)				
		
            for k,v in pairs(Config.Missions[MissionName].Marker) do
                if Active == 1 and MissionName ~="N/A" then
                    ply = PlayerId()
                    coords = GetEntityCoords(GetPlayerPed(ply))
                    if(GetDistanceBetweenCoords(coords.x,coords.y,coords.z, Config.Missions[MissionName].Marker.Position.x, Config.Missions[MissionName].Marker.Position.y, Config.Missions[MissionName].Marker.Position.z, true) > Config.Missions[MissionName].Marker.Size.x / 2)  then
                        securing = false
                    end
                end
            end
        end
    end
end)




--Make Hostage Friendlies cower
--TaskFollowToOffsetOfEntity(passenger, player, -1.0, -1.5, 0, 2, -1, 0, 1) --last arg is persist
--TaskCower(ped,30000)
--TaskSmartFleeCoord(ped, x, y, z, distance, time, p6, p7) --218 --cower : 222
--TaskSeekCoverFromPos(ped, x, y, z, duration, p5)
--359 - CTaskStayInCover, 309 - CTaskInCover
--WILL THIS CODE BE OK IN MP? Multiple clients changing tasks?
Citizen.CreateThread(function()
    while true do
        Citizen.Wait(30000)
		
        if Active == 1 and MissionName ~="N/A" then
	
			for ped in EnumeratePeds() do
			
				if DecorGetInt(ped, "mrppedfriend") > 0 and not getMissionConfigProperty(MissionName, "IsDefend")  then
				
					if not GetIsTaskActive(ped, 222) then
						
						ClearPedTasks(ped)
						TaskCower(ped,360000)
		
					end
				end
				
				
				--if DecorGetInt(ped, "mrppedconqueror") > 0 and getMissionConfigProperty(MissionName, "IsDefend")  then

					--ClearPedTasks(ped)
					--TaskGoStraightToCoord(ped,Config.Missions[MissionName].Marker.Position.x, Config.Missions[MissionName].Marker.Position.y,Config.Missions[MissionName].Marker.Position.z,1200.0 , 100000, 0.0, 0.0) --movespeed = 1200.0
					--SetPedKeepTask(ped,true) 
					
				--end				
				
				
				
			end
						
							
        end
    end
end)


--Cleanup mission pickups

Citizen.CreateThread(function()
    while true do
        Citizen.Wait(5000)
		
        if Active == 1 and MissionName ~="N/A" then
		
					if(Config.Missions[MissionName].MissionPickups) then 	
						
							 for i=1, #Config.Missions[MissionName].MissionPickups do     
								
								--RemoveCollectedPickup(Config.Missions[MissionName].MissionPickups[i].Position.x,Config.Missions[MissionName].MissionPickups[i].Position.y,Config.Missions[MissionName].MissionPickups[i].Position.z)	

								if (DoesPickupExist(Config.Missions[MissionName].MissionPickups[i].id)) then
									if (HasPickupBeenCollected(Config.Missions[MissionName].MissionPickups[i].id)) then
						
										SetEntityAsNoLongerNeeded(Config.Missions[MissionName].MissionPickups[i].id)
										RemovePickup(Config.Missions[MissionName].MissionPickups[i].id)
										DeleteObject(Config.Missions[MissionName].MissionPickups[i].id)				
						
									end							
					
								
								end
			
							end
					end
					
        end
    end
end)

--testing
function round(num, numDecimalPlaces)
  local mult = 10^(numDecimalPlaces or 0)
  return math.floor(num * mult + 0.5) / mult
end



function GetPlayers()
    local players = {}

    for i = 0, 31 do
        if NetworkIsPlayerActive(i) then
            table.insert(players, i)
        end
    end

    return players
end

local firstjoin = true
AddEventHandler("playerSpawned", function(spawn)
	 if(firstjoin) then --should be a first time connecting player
		--lets see if this is the only player and if a mission is running
		
		local players = {}
		local cnt = 0
        ptable = GetPlayers()
        for _, i in ipairs(ptable) do
			cnt = cnt + 1 
        end		
		--if cnt = 1, then only 1 player, this player, 
		--so have server handle to start or restart a mission
		firstjoin = false
		if cnt == 1 then
			TriggerServerEvent("sv:checkmission",true)
		else 
			TriggerServerEvent("sv:checkmission",false)
		end 
	 
	 end 
	
	  
end)



